#!/usr/bin/perl

=head1 NAME

perl_startup.pl -- Initialize mod_perl modules

=head1 SYNOPSIS

    In the Apache configuration file:

    	PerlRequire		etc/perl_startup.pl
	PerlFreshRestart	On	# use for debug

=head1 DESCRIPTION

This is the startup file for pre-loading Apache, CGI, and Acme modules
when the web site starts up.

This program runs once when the Apache Web Server (httpd) starts up.

=cut

BEGIN {
	# Uncomment following if no virtual hosts, and only one library
	# per computer, and ServerRoot directory is same as "DocumentRoot/..".
	# Otherwise, use SITE_LIB environment variable.

	#use Apache ();
	#use lib Apache->server_root_relative('lib');

	use lib $ENV{SITE_LIB};
}

use Apache::Registry;
use Apache::Constants;

use CGI;
use CGI::Carp;

#use Apache::DBI;

# Preload Acme Modules

use Acme::Config;
use Acme::HTML;
use Acme::Security;

use Acme::Base::Schema;
use Acme::SQL;
use Acme::Db;

use Acme::Form;
use Acme::Form::Builder;
use Acme::Form::Filler;
use Acme::Form::Saver;

# Do NOT pre-load the Searcher here as code registered here executes as root
# and Searcher eval's the user's search scripts. Even though those scripts are
# untainted and executed in a Safe module, they should be executed by a
# non-privilaged user. Let Apache clients load the Searcher into their own
# space.
#use Acme::Searcher;

1;
