#!/usr/bin/perl -wT -I../../lib

# Yesterday's callbacks report mailed to administrator.
# This is email intended to be mailed towards the end of the working day so that
# someone can keep up on callbacks.

use Acme::Db;
use Acme::Date	qw(dayadd);
use Acme::Config;
use Local::Acme::Callbacks;

$Callback_Manager  = Acme::Config->Callback_Manager;
$DBTITLE           = Acme::Config->DBTITLE;
$From              = $Callback_Manager =~ /</
		   ? $Callback_Manager
		   : "$DBTITLE<$Callback_Manager>";

local $bgndate = dayadd(-1);		# yesterday's date
local $enddate = $bgndate;

# Count to see if any mail needs to be generated.
my $q = Acme::Db->query( Local::Acme::Callbacks->user_sql($bgndate,$enddate) );

exit 0 unless ($q->count() > 0);	# exit if no callbacks found

delete @ENV{ qw(IFS CDPATH ENV BASH_ENV) };	# untaint
$ENV{PATH} = '/bin:/usr/bin';			# untaint

my $title = "Yesterday's Callbacks Which Have Not Been Acknowledged";

open MAIL, qq[| (cat; cd ..; ./callbacks.cgi bgndate="$bgndate" enddate="$enddate" title="$title" showbanner=no uid_sort=1) | 2>/dev/null /usr/sbin/sendmail -t];

print MAIL "To: Callback Manager <$Callback_Manager>";
print MAIL "From: $From";
print MAIL "Subject: Yesterday's Callbacks Which Have Not Been Acknowledged\n";
print MAIL "Mime-Version: 1.0\n";	# to allow html message
print MAIL "Content-type: text/html\n\n";
close MAIL;

exit 0;
