#!/usr/bin/perl -wT -I../../lib

# Yesterday's callbacks report mailed to users

use Acme::Db;
use Acme::Options	qw(get_options);
use Acme::Date		qw(today	dayadd);
use Acme::Config;
use Local::Acme::Callbacks;

$Email_Send_Domain = Acme::Config->Email_Send_Domain;
$Callback_Manager  = Acme::Config->Callback_Manager;
$DBTITLE           = Acme::Config->DBTITLE;
$From              = $Callback_Manager =~ /</
		   ? $Callback_Manager
		   : "$DBTITLE<$Callback_Manager>";

local $bgndate = dayadd(-1);		# yesterday's date
local $enddate = $bgndate;

my $q = Acme::Db->query( Local::Acme::Callbacks->user_sql($bgndate,$enddate) );

while (($user_id) = $q->next()) {

	my $opt = new Acme::Options user => $user_id;

	my $callbacktoday = $opt->get('CallbacksTodayEmail') || '';

	if ("yes" =~ /^\Q$callbacktoday\E/i) {

		delete @ENV{ qw(IFS CDPATH ENV BASH_ENV) };	# untaint
		$ENV{PATH} = '/bin:/usr/bin';			# untaint

		my $title = "Yesterday's Callbacks Which Have Not Been Acknowledged";

		open MAIL, qq[| (cd ..; cat; ./callbacks.cgi bgndate="$bgndate" enddate="$enddate" title="$title" showbanner=no restrict_uid=1 uid=$user_id) 2>/dev/null | /usr/sbin/sendmail -t];

		print MAIL "To: $user_id\@$Email_Send_Domain\n";
		print MAIL "From: $From\n";
		print MAIL "Subject: Yesterday's Callbacks\n";
		print MAIL "Mime-Version: 1.0\n";
		print MAIL "Content-type: text/html\n\n";
		close MAIL;
    }
}
exit;
