#!/usr/bin/perl -wT -I../lib

=head1 NAME

import.cgi -- Display import screens

=head1 SYNOPSIS

    import.cgi?table=customers

=head1 DESCRIPTION

The import.cgi program imports a set of rows of data in columns with the
first row containing the database column name. Currently, this is primarily
a stub, as only the customer import is working.

=head1 CHANGE LOG

 11/12/02 Initial version.

=head1 AUTHOR

Mack Pexton <mack@acmebase.org>

=head1 COPYRIGHT

Copyright 2002, Mackley F. Pexton.  All rights reserved.

This is open software and is licensed under the terms of the GNU General Public License.

=cut

$|=1;

use Acme::HTML		qw(display_message);
use Acme::Config;
use CGI;

use Acme::Security;
Acme::Security::check('Access');

#
# Begin processing form
#

$|=1;		# flush output (synchronize errors with output)

$cgi = new CGI;

#
# Parse cgi arguments
#

our $table = $cgi->param('table');

if ($table eq 'customers') {
	print $cgi->redirect('/cgi-bin/customers/importcustomers.cgi');
}
else {
	print $cgi->header(-type=>'text/html') unless @ARGV;
	display_message("Only customer import is working at this time.",'','',0);
}

exit;
