#!/usr/bin/perl -wT -I../lib

=head1 NAME

update.cgi -- Display update screens

=head1 SYNOPSIS

    update.cgi?table=customers

=head1 DESCRIPTION

The update.cgi program updates data in a database table from data organized
organized in columns like a spreadsheet. The first line of the columns of
data is the name of the database column to be updated. One of the columns
in the data has to be a column of database table key values.

Currently, this is still under development.

=head1 CHANGE LOG

 12/20/02 Initial version.

=head1 AUTHOR

Mack Pexton <mack@acmebase.org>

=head1 COPYRIGHT

Copyright 2002, Mackley F. Pexton.  All rights reserved.

This is open software and is licensed under the terms of the GNU General Public License.

=cut

$|=1;

use Acme::HTML		qw(display_message);
use Acme::Config;
use CGI;

use Acme::Security;
Acme::Security::check('Access');

#
# Begin processing form
#

$|=1;		# flush output (synchronize errors with output)

$cgi = new CGI;

#
# Parse cgi arguments
#

our $table = $cgi->param('table');

Acme::Security::check('Update',$table);

if (0) {
	print $cgi->redirect('/cgi-bin/customers/updatecustomers.cgi');
}
else {
	print $cgi->header(-type=>'text/html') unless @ARGV;
	display_message("Updating tables from spreadsheets is not completed yet.",'','',0);
}

exit;
