/*
 * Debug CSS by outlining the objects and listing them in a pop-up window.
 */

/**** To turn on, simply include the following in the HTML header:

<script src="/scripts/debug_css.js" type="text/javascript"></script>

***** To operate, press CTRL key with mouse click.  ****/

// To turn on debug, uncomment the following statement.
// Be aware that the form_events.js also captures clicks.
window.document.onclick = debugMark;

// The following functions can also be used to turn on/off the debug.
function debugMarkOn()  { window.document.onclick = debugMark; }
function debugMarkOff() { window.document.onclick = null; }

var debugColors = [ 'red', 'orange', 'yellow', 'green', 'blue', 'purple', 'black' ];
var debugC = -1;

function debugMark(evt) {

	// Need to press CTRL key or Alt key with click to activate.

	if (! (window.event.ctrlKey || window.event.altKey)) return;

	// Print object attributes in a separate window.

	var name = "";
	var settings = "menubar,resizable,scrollbars,status,width=450,height=600";

	var w = window.open("", name, settings);
	var d = w.document;

	d.writeln("<h2>Object Inspector</h2>");

	var obj = window.event.srcElement;

	// Step up through objects
	while (obj) {
		// Set color index.
		debugC = ++debugC % debugColors.length;

		// Output to window interesting properties
		d.writeln("<div style='background-color:"+debugColors[debugC]+"'>&nbsp;</div>");
		if (obj.nodeName) d.writeln("Tag: <b>"+obj.nodeName+"</b>");
		if (obj.name) d.writeln("<br>Name: <b>"+obj.name+"</b>");
		if (obj.id) d.writeln("<br>Id: <b>"+obj.id+"</b>");
		if (obj.className) d.writeln("<br>Class: <b>"+obj.className+"</b>");
		//if (obj.style) d.writeln("<br>Style: <b>"+obj.style+"</b>");
		//if (obj.style) debugObj(obj.style,d);
		if (obj.style.cssText) d.writeln("<br>Style: <b>"+obj.style.cssText+"</b>");
		d.writeln("<br>");

		obj.style.borderColor = debugColors[debugC];
		obj.style.borderStyle = 'solid';
		obj.style.borderWidth = 1;

		obj = obj.parentNode;
	}
}
