/*
 * Form Query Support
 *
 * The following routines provide support for query screens. 
 * 
 * The validation routines below rely on the validation routines in
 * .../lib/form_validation.js.
 */

/*
 * Pop-up parameter window functions
 *
 * The following functions pop-up window to enter the different parts of
 * a query parameter.
 */

var query_args = new Object;

function text_query (field) {

	var settings = "resizable";
	var w,h;

	// Following dimensions are for a lookup window without
	// browser buttons, menu, scrollbar, or status line.
	w=410, h=410;

	settings += ",width="+w+",height="+h;

	// Center new window
	var w_width  = window.document.body.offsetWidth;
	var w_height = window.document.body.offsetHeight;
	var top  = window.screenTop  + (w_height/2 - h);
	var left = window.screenLeft + (w_width/2  - w/2);
	settings += ',top='+top+',left='+left;

	// Save arguments for return
	var wname = "w_" + field.name;
	query_args[wname] = field;

	// Open pop-up window
	var w = window.open("", wname, settings);
	w.focus();

	// Display text query parameters
	w.document.write(
	    '<html>\n'
	  + '<head>\n'
	  + '<title>Text Query</title>\n'
	  + '<link rel="stylesheet" href="/styles/common.css" type="text/css">\n'
	  + '<link rel="stylesheet" href="/styles/form.css" type="text/css">\n'
	  + '<script src="/scripts/lib/form_events.js" type="text/javascript"></script>\n'
	  + '<script src="/scripts/lib/form_validate.js" type="text/javascript"></script>\n'
	  + '<script language="JavaScript" type="text/javascript">\n'
	  + 'function query_results(frm) {\n'
	  + '	var script = "";\n'
	  + '	switch(radio_value(frm.text_param)) {\n'
	  + '		case "begins":\n'
	  + '			script = "^" + frm.bgntext.value + ".*";\n'
	  + '			break;\n'
	  + '		case "ends":\n'
	  + '			script = ".*" + frm.endtext.value + "$";\n'
	  + '			break;\n'
	  + '		case "contains":\n'
	  + '			script = ".*" + frm.containstext.value + ".*";\n'
	  + '			break;\n'
	  + '		case "equal":\n'
	  + '			script = frm.equaltotext.value;\n'
	  + '			break;\n'
	  + '		case "empty":\n'
	  + '			script = "= null";\n'
	  + '			break;\n'
	  + '	}\n'
	  + '	var w = window.opener;\n'
	  + '	if (!w || w.closed || !typeof w.query_return) {\n'
	  + '		self.close(); return false;\n'
	  + '	}\n'
	  + '	w.query_return(window.name, script);\n'
	  + '	self.close();\n'
	  + '	return false;\n'
	  + '}\n'
	  + '</script>\n'
	  + '</head>\n'
	  + '<body>\n'
	  + '<form name="text_query"\n'
	  + '      onSubmit="return query_results(this)"\n'
	  + '      style="padding:3pt"\n'
	  + '>\n'
	  + '<table cellpadding="0" cellspacing="0" border="0" width="98%">\n'
	  + '<tr>\n'
	  + '<td align="left"><span class="title">Text Query</span></td>\n'
	  + '<td align="right">\n'
	  + '<input type="submit" value="Enter " class="button">\n'
	  + '<input type="button" value="Cancel" onClick="self.close()" class="button">\n'
	  + '</td>\n'
	  + '</tr>\n'
	  + '</table>\n'
	  + '<p>Choose which condition you want and enter a search pattern.</>\n'
	  + '<div class="block">\n'
	  + '<table class="form">\n'
	  + '<tr>\n'
	  + '<td align="center" valign="top">1.<input type="radio" name="text_param" value="begins"></td>\n'
	  + '<td align="right">Begins with</td>\n'
	  + '<td><input type="text" name="bgntext" value="" class="text" title="Enter the beginning text." size="24" onChange="if(check_input(this,&#039;text&#039;,10,0)){radio_set(document.text_query.text_param,\'begins\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">2.<input type="radio" name="text_param" value="ends"></td>\n'
	  + '<td align="right">Ends with</td>\n'
	  + '<td><input type="text" name="endtext" value="" class="text" title="Enter the ending text." size="24" onChange="if(check_input(this,&#039;text&#039;,10,0)){radio_set(document.text_query.text_param,\'ends\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">3.<input type="radio" name="text_param" value="contains"></td>\n'
	  + '<td align="right">Contains</td>\n'
	  + '<td><nobr><input type="text" name="containstext" value="" class="text" title="Enter the text to search for anywhere within the field." size="24" onChange="if(check_input(this,&#039;text&#039;,10,0)){radio_set(document.text_query.text_param,\'contains\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">4.<input type="radio" name="text_param" value="equal"></td>\n'
	  + '<td align="right">Equal to</td>\n'
	  + '<td><input type="text" name="equaltotext" value="" class="text" title="Enter the exact text." size="24" onChange="if(check_input(this,&#039;text&#039;,10,0)){radio_set(document.text_query.text_param,\'equal\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">5.<input type="radio" name="text_param" value="empty"></td>\n'
	  + '<td colspan="2">Is empty (null)</td>\n'
	  + '</tr>\n'

	  + '</table>\n'
	  + '</div>\n'
	  + '</form>\n'
	  + '</body>\n'
	  + '</html>\n');
}

function number_query (field) {

	var settings = "resizable";
	var w,h;

	// Following dimensions are for a lookup window without
	// browser buttons, menu, scrollbar, or status line.
	w=360, h=440;

	settings += ",width="+w+",height="+h;

	// Center new window
	var w_width  = window.document.body.offsetWidth;
	var w_height = window.document.body.offsetHeight;
	var top  = window.screenTop  + (w_height/2 - h);
	var left = window.screenLeft + (w_width/2  - w/2);
	settings += ',top='+top+',left='+left;

	// Save arguments for return
	var wname = "w_" + field.name;
	query_args[wname] = field;

	// Open pop-up window
	var w = window.open("", wname, settings);
	w.focus();

	// Display number query parameters
	w.document.write(
	    '<html>\n'
	  + '<head>\n'
	  + '<title>Number Query</title>\n'
	  + '<link rel="stylesheet" href="/styles/common.css" type="text/css">\n'
	  + '<link rel="stylesheet" href="/styles/form.css" type="text/css">\n'
	  + '<script src="/scripts/lib/form_events.js" type="text/javascript"></script>\n'
	  + '<script src="/scripts/lib/form_validate.js" type="text/javascript"></script>\n'
	  + '<script language="JavaScript" type="text/javascript">\n'
	  + 'function query_results(frm) {\n'
	  + '	var script = "";\n'
	  + '	switch(radio_value(frm.number_param)) {\n'
	  + '		case "between":\n'
	  + '			var bn = new Number(frm.bgnnumber.value);\n'
	  + '			var en = new Number(frm.endnumber.value);\n'
	  + '			if (bn.valueOf() <= en.valueOf()) {;\n'
	  + '				script = "$ >= " + frm.bgnnumber.value + " and $ <= " + frm.endnumber.value;\n'
	  + '			} else {\n'
	  + '				script = "$ >= " + frm.endnumber.value + " and $ <= " + frm.bgnnumber.value;\n'
	  + '			}\n'
	  + '			break;\n'
	  + '		case "less":\n'
	  + '			script = "< " + frm.lessthannumber.value;\n'
	  + '			break;\n'
	  + '		case "greater":\n'
	  + '			script = "> " + frm.greaterthannumber.value;\n'
	  + '			break;\n'
	  + '		case "equal":\n'
	  + '			script = frm.equaltonumber.value;\n'
	  + '			break;\n'
	  + '		case "empty":\n'
	  + '			script = "= null";\n'
	  + '			break;\n'
	  + '	}\n'
	  + '	var w = window.opener;\n'
	  + '	if (!w || w.closed || !typeof w.query_return) {\n'
	  + '		self.close(); return false;\n'
	  + '	}\n'
	  + '	w.query_return(window.name, script);\n'
	  + '	self.close();\n'
	  + '	return false;\n'
	  + '}\n'
	  + '</script>\n'
	  + '</head>\n'
	  + '<body>\n'
	  + '<form name="number_query"\n'
	  + '      onSubmit="return query_results(this)"\n'
	  + '      style="padding:3pt"\n'
	  + '>\n'
	  + '<table cellpadding="0" cellspacing="0" border="0" width="98%">\n'
	  + '<tr>\n'
	  + '<td align="left"><span class="title">Number Query</span></td>\n'
	  + '<td align="right">\n'
	  + '<input type="submit" value="Enter " class="button">\n'
	  + '<input type="button" value="Cancel" onClick="self.close()" class="button">\n'
	  + '</td>\n'
	  + '</tr>\n'
	  + '</table>\n'
	  + '<p>Choose which condition you want and enter the search numbers.</>\n'
	  + '<div class="block">\n'
	  + '<table class="form">\n'
	  + '<tr>\n'
	  + '<td align="center" valign="top" rowspan="2">1.<input type="radio" name="number_param" value="between"></td>\n'
	  + '<td align="right">Between</td>\n'
	  + '<td><input type="text" name="bgnnumber" value="" class="number" title="Enter the beginning number." size="10" onChange="if(check_input(this,&#039;number&#039;,10,0)){radio_set(document.number_query.number_param,\'between\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr>\n'
	  + '<td align="right">and</td>\n'
	  + '<td><input type="text" name="endnumber" value="" class="number" title="Enter the ending number." size="10" onChange="if(check_input(this,&#039;number&#039;,10,0)){radio_set(document.number_query.number_param,\'between\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">2.<input type="radio" name="number_param" value="less"></td>\n'
	  + '<td align="right">Less than</td>\n'
	  + '<td><input type="text" name="lessthannumber" value="" class="number" title="Enter the maximum number." size="10" onChange="if(check_input(this,&#039;number&#039;,10,0)){radio_set(document.number_query.number_param,\'less\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">3.<input type="radio" name="number_param" value="greater"></td>\n'
	  + '<td align="right">Greater than</td>\n'
	  + '<td><input type="text" name="greaterthannumber" value="" class="numbenumberaxsize="10" title="Enter the minimum number." size="10" onChange="if(check_input(this,&#039;number&#039;,10,0)){radio_set(document.number_query.number_param,\'greater\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">4.<input type="radio" name="number_param" value="equal"></td>\n'
	  + '<td align="right">Equal to</td>\n'
	  + '<td><input type="text" name="equaltonumber" value="" class="number" title="Enter the exact number." size="10" onChange="if(check_input(this,&#039;number&#039;,10,0)){radio_set(document.number_query.number_param,\'equal\');return true}return false"></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">5.<input type="radio" name="number_param" value="empty"></td>\n'
	  + '<td colspan="2">Is empty (null)</td>\n'
	  + '</tr>\n'

	  + '</table>\n'
	  + '</div>\n'
	  + '</form>\n'
	  + '</body>\n'
	  + '</html>\n');

}

function date_query (field) {

	var settings = "resizable";
	var w,h;

	// Following dimensions are for a lookup window without
	// browser buttons, menu, scrollbar, or status line.
	w=360, h=440;

	settings += ",width="+w+",height="+h;

	// Center new window
	var w_width  = window.document.body.offsetWidth;
	var w_height = window.document.body.offsetHeight;
	var top  = window.screenTop  + (w_height/2 - h);
	var left = window.screenLeft + (w_width/2  - w/2);
	settings += ',top='+top+',left='+left;

	// Save arguments for return
	var wname = "w_" + field.name;
	query_args[wname] = field;

	// Open pop-up window
	var w = window.open("", wname, settings);
	w.focus();

	// Display date query parameters
	w.document.write(
	    '<html>\n'
	  + '<head>\n'
	  + '<title>Date Query</title>\n'
	  + '<link rel="stylesheet" href="/styles/common.css" type="text/css">\n'
	  + '<link rel="stylesheet" href="/styles/form.css" type="text/css">\n'
	  + '<script src="/scripts/lib/form_events.js" type="text/javascript"></script>\n'
	  + '<script src="/scripts/lib/form_validate.js" type="text/javascript"></script>\n'
	  + '<script src="/scripts/lib/calendar.js" type="text/javascript"></script>\n'
	  + '<script language="JavaScript" type="text/javascript">\n'
	  + 'function query_results(frm) {\n'
	  + '	var script = "";\n'
	  + '	switch(radio_value(frm.date_param)) {\n'
	  + '		case "between":\n'
	  + '			var bd = new Date(frm.bgndate.value);\n'
	  + '			var ed = new Date(frm.enddate.value);\n'
	  + '			if (bd.valueOf() <= ed.valueOf()) {;\n'
	  + '				script = frm.bgndate.value + " : " + frm.enddate.value;\n'
	  + '			} else {\n'
	  + '				script = frm.enddate.value + " : " + frm.bgndate.value;\n'
	  + '			}\n'
	  + '			break;\n'
	  + '		case "less":\n'
	  + '			script = "< \'" + frm.lessthandate.value + "\'";\n'
	  + '			break;\n'
	  + '		case "greater":\n'
	  + '			script = "> \'" + frm.greaterthandate.value + "\'";\n'
	  + '			break;\n'
	  + '		case "equal":\n'
	  + '			script = frm.equaltodate.value;\n'
	  + '			break;\n'
	  + '		case "empty":\n'
	  + '			script = "= null";\n'
	  + '			break;\n'
	  + '	}\n'
	  + '	var w = window.opener;\n'
	  + '	if (!w || w.closed || !typeof w.query_return) {\n'
	  + '		self.close(); return false;\n'
	  + '	}\n'
	  + '	w.query_return(window.name, script);\n'
	  + '	self.close();\n'
	  + '	return false;\n'
	  + '}\n'
	  + '</script>\n'
	  + '</head>\n'
	  + '<body>\n'
	  + '<form name="date_query"\n'
	  + '      onSubmit="return query_results(this)"\n'
	  + '      style="padding:3pt"\n'
	  + '>\n'
	  + '<table cellpadding="0" cellspacing="0" border="0" width="98%">\n'
	  + '<tr>\n'
	  + '<td align="left"><span class="title">Date Query</span></td>\n'
	  + '<td align="right">\n'
	  + '<input type="submit" value="Enter " class="button">\n'
	  + '<input type="button" value="Cancel" onClick="self.close()" class="button">\n'
	  + '</td>\n'
	  + '</tr>\n'
	  + '</table>\n'
	  + '<p>Choose which condition you want and enter the search dates.</>\n'
	  + '<div class="block">\n'
	  + '<table class="form">\n'
	  + '<tr>\n'
	  + '<td align="center" valign="top" rowspan="2">1.<input type="radio" name="date_param" value="between"></td>\n'
	  + '<td align="right">Between</td>\n'
	  + '<td><nobr><input type="text" name="bgndate" value="" class="date" title="Enter the begin date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.date_query.date_param,\'between\');return true}return false"><a href="javascript:displayCalendar(1,\'bgndate\',document.date_query.bgndate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr>\n'
	  + '<td align="right">and</td>\n'
	  + '<td><nobr><input type="text" name="enddate" value="" class="date" title="Enter the ending date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.date_query.date_param,\'between\');return true}return false"><a href="javascript:displayCalendar(1,\'enddate\',document.date_query.enddate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">2.<input type="radio" name="date_param" value="less"></td>\n'
	  + '<td align="right">Before</td>\n'
	  + '<td><nobr><input type="text" name="lessthandate" value="" class="date" title="Enter the maximum date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.date_query.date_param,\'less\');return true}return false"><a href="javascript:displayCalendar(1,\'lessthandate\',document.date_query.lessthandate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">3.<input type="radio" name="date_param" value="greater"></td>\n'
	  + '<td align="right">After</td>\n'
	  + '<td><nobr><input type="text" name="greaterthandate" value="" class="date" title="Enter the minimum date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.date_query.date_param,\'greater\');return true}return false"><a href="javascript:displayCalendar(1,\'greaterthandate\',document.date_query.greaterthandate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">4.<input type="radio" name="date_param" value="equal"></td>\n'
	  + '<td align="right">Equal to</td>\n'
	  + '<td><nobr><input type="text" name="equaltodate" value="" class="date" title="Enter the exact date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.date_query.date_param,\'equal\');return true}return false"><a href="javascript:displayCalendar(1,\'equaltodate\',document.date_query.equaltodate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">5.<input type="radio" name="date_param" value="empty"></td>\n'
	  + '<td colspan="2">Is empty (null)</td>\n'
	  + '</tr>\n'

	  + '</table>\n'
	  + '</div>\n'
	  + '</form>\n'
	  + '</body>\n'
	  + '</html>\n');
}

function time_query (field) {

	var settings = "resizable";
	var w,h;

	// Following dimensions are for a lookup window without
	// browser buttons, menu, scrollbar, or status line.
	w=460, h=440;

	settings += ",width="+w+",height="+h;

	// Center new window
	var w_width  = window.document.body.offsetWidth;
	var w_height = window.document.body.offsetHeight;
	var top  = window.screenTop  + (w_height/2 - h);
	var left = window.screenLeft + (w_width/2  - w/2);
	settings += ',top='+top+',left='+left;

	// Save arguments for return
	var wname = "w_" + field.name;
	query_args[wname] = field;

	// Open pop-up window
	var w = window.open("", wname, settings);
	w.focus();

	// Display date and time query parameters
	w.document.write(
	    '<html>\n'
	  + '<head>\n'
	  + '<title>Time Query</title>\n'
	  + '<link rel="stylesheet" href="/styles/common.css" type="text/css">\n'
	  + '<link rel="stylesheet" href="/styles/form.css" type="text/css">\n'
	  + '<script src="/scripts/lib/form_events.js" type="text/javascript"></script>\n'
	  + '<script src="/scripts/lib/form_validate.js" type="text/javascript"></script>\n'
	  + '<script language="JavaScript" type="text/javascript">\n'
	  + 'function query_results(frm) {\n'
	  + '	var script = "";\n'
	  + '	switch(radio_value(frm.time_param)) {\n'
	  + '		case "between":\n'
	  + '			script = frm.bgndate.value + " " + frm.bgntime.value + " : " + frm.enddate.value + " " + frm.endtime.value;\n'
	  + '			break;\n'
	  + '		case "less":\n'
	  + '			script = "< \'" + frm.lessthandate.value + " " + frm.lessthantime.value + "\'";\n'
	  + '			break;\n'
	  + '		case "greater":\n'
	  + '			script = "> \'" + frm.greaterthandate.value + " " + frm.greaterthantime.value + "\'";\n'
	  + '			break;\n'
	  + '		case "equal":\n'
	  + '			script = frm.equaltodate.value + " " + frm.equaltotime.value;\n'
	  + '			break;\n'
	  + '		case "empty":\n'
	  + '			script = "= null";\n'
	  + '			break;\n'
	  + '	}\n'
	  + '	var w = window.opener;\n'
	  + '	if (!w || w.closed || !typeof w.query_return) {\n'
	  + '		self.close(); return false;\n'
	  + '	}\n'
	  + '	w.query_return(window.name, script);\n'
	  + '	self.close();\n'
	  + '	return false;\n'
	  + '}\n'
	  + '</script>\n'
	  + '</head>\n'
	  + '<body>\n'
	  + '<form name="time_query"\n'
	  + '      onSubmit="return query_results(this)"\n'
	  + '      style="padding:3pt"\n'
	  + '>\n'
	  + '<table cellpadding="0" cellspacing="0" border="0" width="98%">\n'
	  + '<tr>\n'
	  + '<td align="left"><span class="title">Time Query</span></td>\n'
	  + '<td align="right">\n'
	  + '<input type="submit" value="Enter " class="button">\n'
	  + '<input type="button" value="Cancel" onClick="self.close()" class="button">\n'
	  + '</td>\n'
	  + '</tr>\n'
	  + '</table>\n'
	  + '<p>Choose which condition you want and enter the search times.</>\n'
	  + '<div class="block">\n'
	  + '<table class="form">\n'
	  + '<tr>\n'
	  + '<td align="center" valign="top" rowspan="2">1.<input type="radio" name="time_param" value="between"></td>\n'
	  + '<td align="right">Between</td>\n'
	  + '<td><nobr><input type="text" name="bgndate" value="" class="date" title="Enter the begin date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.time_query.time_param,\'between\');return true}return false"><a href="javascript:displayCalendar(1,\'bgndate\',document.time_query.bgndate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a> Time <input type="text" name="bgntime" value="00:00" class="time" title="Enter the begin time." size="10" onChange="if(check_input(this,&#039;time&#039;,10,0)){radio_set(document.time_query.time_param,\'between\');return true}return false"></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr>\n'
	  + '<td align="right">and</td>\n'
	  + '<td><nobr><input type="text" name="enddate" value="" class="date" title="Enter the ending date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.time_query.time_param,\'between\');return true}return false"><a href="javascript:displayCalendar(1,\'enddate\',document.time_query.enddate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a> Time <input type="text" name="endtime" value="23:59" class="time" title="Enter the ending time." size="10" onChange="if(check_input(this,&#039;time&#039;,10,0)){radio_set(document.time_query.time_param,\'between\');return true}return false"></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">2.<input type="radio" name="time_param" value="less"></td>\n'
	  + '<td align="right">Before</td>\n'
	  + '<td><nobr><input type="text" name="lessthandate" value="" class="date" title="Enter the maximum date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.time_query.time_param,\'less\');return true}return false"><a href="javascript:displayCalendar(1,\'lessthandate\',document.time_query.lessthandate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a> Time <input type="text" name="lessthantime" value="00:00" class="time" title="Enter the maximum time." size="10" onChange="if(check_input(this,&#039;time&#039;,10,0)){radio_set(document.time_query.time_param,\'less\');return true}return false"></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">3.<input type="radio" name="time_param" value="greater"></td>\n'
	  + '<td align="right">After</td>\n'
	  + '<td><nobr><input type="text" name="greaterthandate" value="" class="date" title="Enter the minimum date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.time_query.time_param,\'greater\');return true}return false"><a href="javascript:displayCalendar(1,\'greaterthandate\',document.time_query.greaterthandate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a> Time <input type="text" name="greaterthantime" value="23:59" class="time" title="Enter the minimum time." size="10" onChange="if(check_input(this,&#039;time&#039;,10,0)){radio_set(document.time_query.time_param,\'greater\');return true}return false"></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">4.<input type="radio" name="time_param" value="equal"></td>\n'
	  + '<td align="right">Equal to</td>\n'
	  + '<td><nobr><input type="text" name="equaltodate" value="" class="date" title="Enter the exact date." size="10" onChange="if(check_input(this,&#039;date&#039;,10,0)){radio_set(document.time_query.time_param,\'equal\');return true}return false"><a href="javascript:displayCalendar(1,\'equaltodate\',document.time_query.equaltodate.value)" title="Display a calendar." tabindex="-1"><img src="/images/transparent.gif" border="0" width="7" height="13"><img src="/images/calendar.gif" border=0 onMouseOver="this.src=\'/images/calendar_hilite.gif\'" onMouseOut="this.src=\'/images/calendar.gif\'"></a> Time <input type="text" name="equaltotime" value="" class="time" title="Enter the exact time." size="10" onChange="if(check_input(this,&#039;time&#039;,10,0)){radio_set(document.time_query.time_param,\'equal\');return true}return false"></nobr></td>\n'
	  + '</tr>\n'

	  + '<tr><td colspan="3"><hr width="98%"></td></tr>\n'

	  + '<tr>\n'
	  + '<td align="center" valign="top">5.<input type="radio" name="time_param" value="empty"></td>\n'
	  + '<td colspan="2">Is empty (null)</td>\n'
	  + '</tr>\n'

	  + '</table>\n'
	  + '</div>\n'
	  + '</form>\n'
	  + '</body>\n'
	  + '</html>\n');
}

/*
 * Return from pop-up window routine.
 *
 * This is a common return function for text_query(), number_query(),
 * date_query(), and time_query().
 */

function query_return(wname,script) {
	var field = query_args[wname];

	// This routine assumes that the calling function's window,
	// the window opened above, will close itself after calling this.

	if (!script) return false;	// no return value

	field.value = script;

	field.focus();
	if (field.select) field.select();

	if (field.onchange) {
		// execute the onChange event function

		/*
		 * Note: this should be called like Javascript calls
		 * an event handler. But I haven't figured that out yet
		 * so I just substitute 'field' for any reference
		 * to 'this'. IE uses the function name 'anonymous()'
		 * but Netscape uses 'onchange()'. Netscape needs a
		 * event parameter passed to the handler, according
		 * to its syntax.
		 */

		var func = field.onchange.toString();
		func = func.replace(/\bthis\b/g,"field");
		func.match(/(\w+) (\w+)/);
		var func_call = RegExp.$2;

		if ( eval(func + ";" + func_call + "()") == false) {
			return false;
		}
	}

	return true;
}
