/*
 * List processing routines
 */

self.focus();	// Netscape gets confused which window should be on top

// Constants
var Browse_Prog      = "/cgi-bin/browse.cgi";
var Save_List_Prog   = "/cgi-bin/list/save_list.cgi";
var Save_Report_Prog = "/cgi-bin/list/save_report.cgi";
var Compare_Prog     = "/cgi-bin/list/compare.cgi";

// Defaults
var Log_Prog         = "/cgi-bin/list/log.cgi";
var Export_Prog      = "/cgi-bin/list/export.cgi";
var Email_Prog       = "/cgi-bin/list/email.cgi";
var Edit_Prog        = "/cgi-bin/list/edit.cgi";
var View_Prog        = "/cgi-bin/view.cgi";

// Save current url
var List_URL = location.href.replace(/\?.*/,"");

// Preload and cache button images.
var imgs = new Array;
function preload_imgs() {
	var i,j;
	for (i = 0; i < arguments.length; i++) {
		imgs[(j=imgs.length)] = new Image;
		imgs[j].src = arguments[i];
	}
}
preload_imgs(
	"/images/blank.gif",
	"/images/checked.gif",
	"/images/checked_hilite.gif",
	"/images/unchecked.gif",
	"/images/unchecked_hilite.gif",
	"/images/check.gif",
	"/images/nocheck.gif");

// Define globals.
var nrows        = 0;
var nchecked     = 0;
var nunchecked   = 0;
var nexcluded    = 0;
var nincluded    = 0;

var excluded_rows = new Array();
var included_rows = new Array();

// Define number to use for new window names (to provide semi-uniqueness).
var wn = Math.floor(Math.random() * 10000);

/* ------------------------------------------------------------------------ */
/*                                                                          */
/* Row Highlight Functions                                                  */
/*                                                                          */
/* ------------------------------------------------------------------------ */

var nohilo = false;		// User setting for turning on/off highlights.

var isOpr    = (navigator.userAgent.indexOf("Opera")    >= 0) ? true : false;
var isIE     = (document.all && ! isOpr);

function hi(row) {
	// Highlight a row by adding "-hilite" to its class name.

	if (nohilo) return;	// user option flag
	if (! row)  return;

	if (isIE) {
		// Hardwire style. Its faster than changing class names.
		// Does not work in Opera 7.

		row.style.backgroundColor = "FFFFDC";	// light yellow
	}
	else {
		// Use class names, not hardwired styles.
		// Works across browsers, but is slow in IE5 and Opera 7.

		row.className += "-hilite";
	}
}
function lo(row) {
	// Un-highlight a row by removing "-hilite" suffix from its class name.

	if (nohilo) return;	// user option flag
	if (! row)  return;

	if (isIE) {
		// Hardwire style. Its faster than changing class names.
		// Does not work in Opera 7.

		// return to previous background color
		//row.style.backgroundColor = "transparent";
		row.style.backgroundColor = "";
	}
	else {
		// Use class names, not hardwired styles.
		// Works across browsers, but is slow in IE5 and Opera 7.

		row.className = row.className.replace(/-hilite$/,"");
	}
}

function do_click(eid,evt) {
	// Click the check selector icon.
	
	if (nohilo) return;	// user option flag

	// This should be invoked only by TD elements of list table.
	// Let the A tags do their own stuff without triggering a flip.
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var target = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;
	if (evt && target && isNodeName(target,"A")) return;

	var e = document.getElementById(eid);
	if (e) flip(e);
}

function do_dblclick(eid,url,evt) {
	// View record
	
	if (nohilo) return;	// user option flag

	// This should be invoked only by TD elements of list table.
	// Let the A tags do their own stuff without triggering a click.
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var target = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;
	if (evt && target && isNodeName(target,"A")) return;

	do_click(eid);		// undo click() event that was also fired
	open_view(url);
}

function isNodeName(e,name) {

	// Return true if the given element e or any of its parents is a node
	// with a type name equal to the given name (e.g. A for <a> tags).

	while (e) {
		if (e.nodeName == name) return true;
		e = e.parentNode;
	}
	return false;
}

/* ------------------------------------------------------------------------ */
/*                                                                          */
/* List Option Functions                                                    */
/*                                                                          */
/* ------------------------------------------------------------------------ */

function list_as_rows() {

	prepare_list_control_form();

	var f = document.list_control;

	if (f.list_as_rows.value == "yes") {
		// Toggle Off
		f.list_as_rows.value    = "no";
		f.list_as_table.value   = "yes";
	}
	else {
		// Toggle On
		f.list_as_rows.value    = "yes";
		f.list_as_table.value   = "no";
		f.list_all_columns.value = "no";
	}

	f.request.value = "List";

	// Undo flag which turns off customization.
	f.customize.value = f.customize.value == "none" ? "previous" : "";

	prepare_list_options();

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */

function list_as_table() {

	prepare_list_control_form();

	var f = document.list_control;

	if (f.list_as_table.value == "yes") {
		// Toggle Off
		f.list_as_rows.value  = "yes";
		f.list_as_table.value = "no";
	}
	else {
		// Toggle On
		f.list_as_rows.value  = "no";
		f.list_as_table.value = "yes";
	}

	f.request.value = "List";

	// Undo flag which turns off customization.
	f.customize.value = f.customize.value == "none" ? "previous" : "";

	prepare_list_options();

	// Do not save the current columns set by the list_as_row options.
	for(var i = 0; i < f.columns.options.length; i++) {
		if (f.columns.options[i] != null) {
			f.columns.options[i].selected = false;	// clear
		}
	}

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */

function list_all_columns() {

	prepare_list_control_form();

	var f = document.list_control;

	if (f.list_all_columns.value == "yes") {
		// Toggle Off
		f.list_all_columns.value = "no";
	}
	else {
		// Toggle On
		f.list_all_columns.value = "yes";

		// Toggle table list too
		f.list_as_table.value = "yes";
		f.list_as_rows.value = "no";
	}

	f.request.value = "List";

	// Undo flag which turns off customization.
	f.customize.value = f.customize.value == "none" ? "previous" : "";

	prepare_list_options();

	if (f.list_all_columns.value == "no") {
		// Clear display columns so they are reset to original
		// display columns next time.
		for(var i = 0; i < f.columns.options.length; i++) {
			if (f.columns.options[i] != null) {
				f.columns.options[i].selected = false;
			}
		}
	}

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */

function list_as_count() {

	prepare_list_control_form();

	var f = document.list_control;

	if (f.request.value == "Count") {
		// Toggle Off
		f.list_as_rows.value     = "yes";
		f.list_as_table.value    = "no";
		f.list_all_columns.value = "no";

		f.request.value = "List";
	}
	else {
		// Toggle On
		f.list_as_rows.value     = "no";
		f.list_as_table.value    = "no";
		f.list_all_columns.value = "no";

		f.request.value = "Count";
	}

	// Undo flag which turns off customization.
	f.customize.value = f.customize.value == "none" ? "previous" : "";

	prepare_list_options();

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */

function format_style(opt) {

	prepare_list_control_form();

	var f = document.list_control;

	f.list_format_style.value = opt;

	// Undo flag which turns off customization.
	f.customize.value = f.customize.value == "none" ? "previous" : "";

	prepare_list_options();

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */

function column_headers(opt) {

	prepare_list_control_form();

	var f = document.list_control;

	f.list_column_headers.value = opt;

	// Undo flag which turns off customization.
	f.customize.value = f.customize.value == "none" ? "previous" : "";

	// Toggle list as table
	f.list_as_table.value = "yes";
	f.list_as_rows.value = "no";

	prepare_list_options();

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */

function customize(opt) {

	prepare_list_control_form();

	var f = document.list_control;

	f.customize.value = opt;

	prepare_list_options();

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */

function search_reset() {
	var f = document.list_control;

	// Reset list settings when search script changes.

	f.original_search.value=f.search.value;

	f.report_id.value = "";
	f.title.value = "";
	f.list_title.value = "";
	f.redrawing.value = "";

	return true;
}

/* ------------------------------------------------------------------------ */

function set_available_group_columns_to_sort_columns() {

	// Delete items in avaliable_group_columns and set to the items
	// in the sort_columns.

        var f = document.list_control;

	// Delete options from end to beginning.
	var o = f.available_group_columns.options;
	for (var i = o.length-1; i >= 0; i--) { o[i] = null; }

	// Set available columns to the sorted columns
	var sorted = f.sort_columns.options;
	var t,v;
	var avail = {};
	for (var i = 0; i < sorted.length; i++) {
		t = v = sorted[i].text.replace(/ desc$/,"");
		o[i] = new Option(t,v);
		avail[t] = true;
	}

	// Scan group columns removing those not in the sorted columns
	var grouped = f.group_columns.options;
	for (var i = grouped.length - 1; i >= 0; i--) {
		if (! avail[ grouped[i].text.replace(/ desc$/,"") ]) {
			grouped[i] = null;	// delete
		}
	}
}

/* ------------------------------------------------------------------------ */

function compute_filter(fld) {
        // Recompute the total of the filter.

	// There are three fields with related names. The checkbox field
	// has the name Cnn_field where "nn" is a number and "field" is the
	// database column name. The field holding the category count has
	// the name Fnn_field where "nn" and "field" correspond to the
	// Cnn_field name. The field holding the total of all filter
	// categories is named T_field.

	// Checking or unchecking the checkbox field Cnn_field causes the
	// corresponding value of the field Fnn_field to be added or
	// subtracted from the total field T_field.

	var f = fld.form;
	var fieldname = fld.name.replace(/^C/,"F");
	var v = 0;
	if (f[fieldname]) v = parseInt(f[fieldname].value);
	var fieldname = fieldname.replace(/^F\d*/,"T");	// change to total field
	if (f[fieldname]) {
		if (fld.checked) {
			f[fieldname].value = parseInt(f[fieldname].value) + v;
		}
		else {
			f[fieldname].value = parseInt(f[fieldname].value) - v;
		}
	}
}

/* ------------------------------------------------------------------------ */

function filter(f) {
	// Scan the filter form's checkboxes and build SQL "where" clauses to
	// append to the search parameter.

	// Note: this started out to be a "quick & dirty" application of a 
	// filter by simply adjusting the search's where clause that gets
	// combined with the SQL. However, that did not allow for the
	// removal of filters, so now a filter defines a variable in the
	// search script that has the filter's column name preceded with
	// "$FLTR_", and then that variable is included in the search
	// script's where clause. That is done so that there is a
	// "well defined" pattern to search on to remove a filter (done on
	// the server). However, that means that the filter values are
	// interpreted by the search script evaluator before merging into
	// the where clause -- meaning that fields cannot contain the characters
	// used as quote characters (currently "[" and "]").

	// Store filter values to include/exclude from SQL.
	var filter_include = {};	// hash of arrays, keyed by column name
	var filter_exclude = {};	// hash of arrays, keyed by column name

	var field;			// "table__column" format
	var fld, val;
	for (var i=0; i < f.elements.length; i++) {
		// The elements beginning with C are the checkboxes.
		fld = f.elements[i];
		if (! (fld.name.substr(0,1) == "C" && fld.type == "checkbox")) continue;

		field = fld.name.replace(/^C\d*_/,"");

		if (fld.checked) {
			// Store value in filter_include.
			if (! filter_include[field]) filter_include[field] = [];
			filter_include[field][ filter_include[field].length ] = fld.value;
		}
		else {
			// Store value in filter_exclude.
			if (! filter_exclude[field]) filter_exclude[field] = [];
			filter_exclude[field][ filter_exclude[field].length ] = fld.value;
		}
	}

	// Check that at least one filter category is selected in each filter.
	for (field in filter_exclude) {
		if (typeof filter_include[field] == "undefined") {
			alert("At least one filter category needs to be checked\n" +
			      "otherwise there won't be any rows to select.");
			return;
		}
	}

	var search = document.list_control.search.value;

	// Find which separator (| or ;) used for search script.

	var sep = search.indexOf("|") >= 0
		? "|"
		: search.indexOf(";") >= 0
		? ";"
		: ";";	// default is semi-colon

	// Split search script into an array of lines.

	var re = new RegExp(sep + "\\s*");
	var script = search.split(re);

	// Add blank search where clause if search script ends with a separator.
	re = new RegExp(sep + "\\s*$");
	if (search.match(re)) script[script.length++] = "";

	var search_where = script[script.length-1]; script.length--;	// pop

	// Construct new search script with filters.

	var col, where_clause, null_clause, null_flag;
	var ia, val;	// array of "include" values
	var fltr_name;	// name of the filter: $FLTR_table__column
	var filters = new Array;	// filters constructed
	var i, script_found;

	for (field in filter_include) {

		// No filter clause is necessary if all are included
		// and none are excluded.

		if (typeof filter_exclude[field] == "undefined") continue;

		// Define filter name.
		fltr_name = "$FLTR_" + field;

		// Turn field name into sql column name.
		col = field.replace(/__/,".");

		// Build a filter clause only from the filter_include arrays.
		// Escape ' quotes in SQL and change empty strings to null.

		where_clause = null_clause = "";
		null_flag = false;

		ia = filter_include[field];
		for (val in filter_include[field]) {
			if (ia[val].length == 0) {
				null_flag = true;
				delete ia[val];
				continue;
			}

			ia[val] = ia[val].replace(/'/g,"''");
			where_clause += ",'" + ia[val] + "'";
		}

		if (null_flag && where_clause) {
			where_clause = "(" +
					col +
					" is null or " +
					col +
					" in (" +
					where_clause.substr(1) +
					"))";
		}
		else if (null_flag) {
			where_clause = col + " is null";
		}
		else if (where_clause) {
			if (where_clause == ",'(not empty)'") {
				where_clause = col + " is not null";
			}
			else {
				where_clause =	col +
						" in (" +
						where_clause.substr(1) +
						")";
			}
		}

		// Check to see if filter already exists in search script.

		script_found = false;
		for (i = 0; i < script.length; i++) {
			re = new RegExp("^\\" + fltr_name + "\\s*=");
			if (script[i].match(re)) {

				// Substitute new set of values to include
				script[i] = fltr_name + "=q[" + where_clause + "]";
				script_found = true;
				break;
			}
		}

		if (! script_found) {

			// Add filter definition to search script.
			if (script.length == 0) script[0] = "";	// ensure first line is title
			script[script.length] = fltr_name + "=q[" + where_clause + "]";
			search_where += (search_where.length > 0 ? " and " : "") + fltr_name;
		}
	}
	// Add back where clause stripped above.
	script[script.length] = search_where;

	document.list_control.search.value = script.join(sep + "\n");

	// Enter description of filter into the list annotation.
	// This records the values that are excluded, whereas the
	// search script uses the values to include in the query.

	var desc = "";
	var desc_clause, desc_prefix;
	var annotate = document.list_control.annotate.value;

	for (field in filter_exclude) {

		// Build list of fields excluded for list annotation.

		// Turn field name into sql column name.
		col = field.replace(/__/,".");

		desc_clause = "";

		ia = filter_exclude[field];
		for (val in filter_exclude[field]) {
			desc_clause += ', ' + (ia[val] == '' ? '(empty)' : ia[val]) + '';
		}

		if (desc_clause == "") continue;

		// Get current filter description from annotation.
		desc_prefix = 'A filter on "' + col + '" has excluded the values: ';

		re = new RegExp(desc_prefix + "([^.]+)\\.\\s+");
		re.multiline = true;

		if (annotate.match(re)) {

			// Substitute current values into annotation.
			desc_clause = RegExp.$1 + desc_clause;
			annotate = annotate.replace(re,desc_prefix + desc_clause + ". ");
		}
		else {
		
			// Add filter description to annotation.
			annotate += (annotate ? "<br>" : "") + desc_prefix + desc_clause.substr(1) + ". ";
		}
	}
	document.list_control.annotate.value = annotate;

	submit_param();		// submit list_control form
}

/* ------------------------------------------------------------------------ */

function filter_reset() {
	var f = document.list_control;

	// Clear filter_desc settings, they are no longer valid as
	// filter_desc is a parallel array to filters.

	if (f.filter_desc) {
		f.filter_desc.value = "";
	}
}

/* ------------------------------------------------------------------------ */

function submit_selector() {
	// Set a new selector field.
	// Clear any included_rows/excluded_rows/invert_all/select_all settings

	clear_selector();

	submit_param();		// submit list_control form
}

/* ------------------------------------------------------------------------ */

function clear_selector() {
	var f = document.list_control;

	// Reset all the fields that make up the selector filter.

	f.invert_all.value = "";
	f.select_all.value = "";

	// Clear out included_rows and excluded_rows array's.
	included_rows.length = excluded_rows.length = 0;
	nexcluded = nincluded = 0;
}

/* ------------------------------------------------------------------------ */

var select_reset_done = false;	// flag

function select_reset() {
	var f = document.list_control;

	// Reset include/exclude and insert_all/select_all settings.

	if (! select_reset_done &&
	    (f.invert_all.value == "yes" || f.select_all.value == "yes" ||
	    nincluded > 0 || nexcluded > 0) ) {

	    	if (! confirm("Changing the selector condition will clear all" +
			      " your checks and unchecks.\n" +
			      "Do you want to continue?")) {
			return false;
		}
	}

	clear_selector();

	select_reset_done = true;
}

/* ------------------------------------------------------------------------ */

// Define object of conditions and number of parameters they need.
var Selector_Conds = {	"null"		: 0,
			"not null"	: 0,
			"eq"		: 1,
			"ne"		: 1,
			"lt"		: 1,
			"le"		: 1,
			"gt"		: 1,
			"ge"		: 1,
			"between"	: 2,
			"not between"	: 2,
			"in"		: 3,
			"not in"	: 3,
			"matches"	: 1,
			"not matches"	: 1};

function select_cond() {
	var f = document.list_control;

	// Show/Hide condition and it's parameters.
	// This gets executed when the record selector column or the
	// condition setting changes.

	var e_cond   = document.getElementById("l_selector_cond");
	var e_param1 = document.getElementById("l_selector_param1");
	var e_param2 = document.getElementById("l_selector_param2");
	var e_label2 = document.getElementById("l_selector_param2_label");
	var e_param3 = document.getElementById("l_selector_param3");

	var e_desc   = document.getElementById("l_cond_desc");
	var e_none   = document.getElementById("l_none_desc");
	var e_all    = document.getElementById("l_all_desc");
	var e_schema = document.getElementById("l_schema_desc");

	// Special case, hide all conditions if selector is set to "(none)" or "(all)".
	if (f.selector.value == "(none)" || f.selector.value == "(all)") {
		// Hide all
		e_cond.style.display   = "none";
		e_param1.style.display = "none";
		e_param2.style.display = "none";
		e_label2.style.display = "none";
		e_param3.style.display = "none";

		if (f.selector.value == "(none)" && e_none) {
			e_none.style.display   = "inline";
			e_all.style.display    = "none";
		}
		else if (f.selector.value == "(all)" && e_all) {
			e_none.style.display   = "none";
			e_all.style.display    = "inline";
		}

		e_desc.style.display = "none";
		if (e_schema) e_schema.style.display = "none";

		return;
	}

	// Hide old style selector type message if any column is selected.
	if (e_schema && f.selector.selectedIndex < 0) {
		// No column is selected.
		e_desc.style.display   = "none";
		e_none.style.display   = "none";
		e_all.style.display    = "none";
		e_schema.style.display = "inline";

		e_cond.style.display   = "none";
		e_param1.style.display = "none";
		e_param2.style.display = "none";
		e_label2.style.display = "none";
		e_param3.style.display = "none";
		return;
	}

	var n = (f.selector_cond.selectedIndex && f.selector_cond.selectedIndex > 0)
		? f.selector_cond.selectedIndex
		: 1;

	var c = f.selector_cond[ n ].value;

	var np = Selector_Conds[ c ];	// number of parameters for condition

	if (np == 0) {
		e_cond.style.display   = "inline";
		e_param1.style.display = "none";
		e_param2.style.display = "none";
		e_label2.style.display = "none";
		e_param3.style.display = "none";
	}
	else if (np == 1) {
		e_cond.style.display   = "inline";
		e_param1.style.display = "inline";
		e_param2.style.display = "none";
		e_label2.style.display = "none";
		e_param3.style.display = "none";
	}
	else if (np == 2) {
		e_cond.style.display   = "inline";
		e_param1.style.display = "inline";
		e_param2.style.display = "inline";
		e_label2.style.display = "inline";
		e_param3.style.display = "none";
	}
	else if (np == 3) {
		e_cond.style.display   = "inline";
		e_param1.style.display = "none";
		e_param2.style.display = "none";
		e_label2.style.display = "none";
		e_param3.style.display = "inline";
	}

	e_desc.style.display = "inline";
	e_none.style.display = "none";
	e_all.style.display  = "none";
	if (e_schema) e_schema.style.display = "none";
}

/* ------------------------------------------------------------------------ */

function submit_param() {

	// Submitting parameter forms implies displaying list as a table.
	prepare_list_control_form();

	var f = document.list_control;

	// Undo flag which turns off customization.
	f.customize.value = f.customize.value == "none" ? "previous" : "";

	prepare_list_options();

	f.target = "";
	f.action = List_URL;

	f.submit();
}

/* ------------------------------------------------------------------------ */
/*                                                                          */
/* Prepare list for submittal.                                              */
/*                                                                          */
/* ------------------------------------------------------------------------ */

function prepare_list_control_form(request) {

	// Fill in hidden form fields before submitting.

	var f = document.list_control;

	if (request) f.request.value = request;

	f.n_rows.value        = nrows;
	f.n_checked.value     = nchecked;
	f.n_unchecked.value   = nunchecked;

	var i;
	var s = new String;

	f.include.value = "";	// initialize
	f.exclude.value = "";	// initialize

	if (nexcluded > 0) {
		// find first 
		for (i=0; i < excluded_rows.length; i++)  {
			if (excluded_rows[i]) {
				// ID numbers are not quoted, other key values are.
				s = excluded_rows[i].toString();
				f.exclude.value = s.match(/[^\d]/) ? "'"+s+"'" : s;
				break;
			}
		}
		for (i=++i; i < excluded_rows.length; i++) {
			if (excluded_rows[i]) {
				s = excluded_rows[i].toString();
				f.exclude.value += ","+(s.match(/[^\d]/) ? "'"+s+"'" : s);
			}
		}
	}
	
	if (nincluded > 0) {
		// find first 
		for (i=0; i < included_rows.length; i++) {
			if (included_rows[i]) {
				// ID numbers are not quoted, other key values are.
				s = included_rows[i].toString();
				f.include.value = s.match(/[^\d]/) ? "'"+s+"'" : s;
				break;
			}
		}
		for (i=++i; i < included_rows.length; i++) {
			if (included_rows[i]) {
				s = included_rows[i].toString();
				f.include.value += ","+(s.match(/[^\d]/) ? "'"+s+"'" : s);
			}
		}
	}
}

/* ------------------------------------------------------------------------ */

function prepare_list_options() {
	var f = document.list_control;

	selectList(f.columns);
	selectList(f.sort_columns);
	selectList(f.total_columns);
	selectList(f.group_columns);
	selectList(f.filter_columns);
}

/* ------------------------------------------------------------------------ */

function selectList(sourceList) {

	// Select all the items in a <select> list before submitting the form.

	for(var i = 0; i < sourceList.options.length; i++) {
		if (sourceList.options[i] != null) {
			sourceList.options[i].selected = true;
		}
	}
	return true;
}

/* ------------------------------------------------------------------------ */
/*                                                                          */
/* List Menu Functions                                                      */
/*                                                                          */
/* ------------------------------------------------------------------------ */

function do_open_report(report_id) {
	// Open a report file
	browse_reports(report_id,window.do_open_report_file);
}


function do_open_report_file(file_name) {
	var f = window.document.list_control;

	self.location.href = self.location.href +
	  (self.location.href.indexOf("?") >= 0 ? "&" : "?") +
	  "report=" + escape(file_name)      + "&" +
	  "search=" + escape(f.search.value) + "&" +
	  "table="  + f.table.value;
}
	
/* ------------------------------------------------------------------------ */

function do_save_report() {
	// Save list settings to a file

	prepare_list_control_form();
	prepare_list_options();

	var f = window.document.list_control;

	f.target = "Report" + wn++;
	f.action = Save_Report_Prog;

	var settings = "menubar,resizable,scrollbars,status" +
	  ",width=600,height=600";

	open_window("", f.target, settings);

	f.submit();
}
	
/* ------------------------------------------------------------------------ */

function do_print() {
	// Print list

	prepare_list_control_form();
	prepare_list_options();

	var f = window.document.list_control;

	f.target = "List" + wn++;
	f.action = self.location.href;

	// Add print command to action url.
	var sep = "?";
	if (f.action.match(/[?]/)) sep = "&";
	if (f.action.match(/[?&;]$/)) sep = "";

	f.action += sep+"print=yes";

	open_print("",f.target);

	f.submit();
}
	
/* ------------------------------------------------------------------------ */
/*                                                                          */
/* Button Bar Button Functions                                              */
/*                                                                          */
/* ------------------------------------------------------------------------ */


function do_open(list_id) {
	// Open a list file
	browse_lists(list_id,window.do_open_file);
}


function do_open_file(file_name) {
	var f = window.document.list_control;
	var title = 'List "' + file_name + '"';

	// Redefine search
	f.search.value = title + ";list_join('" +
					file_name + "','" +
					f.table.value + "." + f.key.value +
					"');";

	// Reset list options and control fields
	f.report_id.value = "";
	f.title.value = "";
	f.list_title.value = title;
	f.annotate.value = "";
	f.include.value = "";
	f.exclude.value = "";
	f.invert_all.value = "";
	f.select_all.value = "";
	f.redrawing.value = "";

	f.target = "";
	f.action = self.location.href;

	f.submit();
}
	
/* ------------------------------------------------------------------------ */

function do_save() {
	// Save list to a file

	prepare_list_control_form();

	var f = window.document.list_control;

	f.target = "List" + wn++;
	f.action = Save_List_Prog;

	var settings = "menubar,resizable,scrollbars,status" +
	  ",width=600,height=600";

	open_window("", f.target, settings);
	f.submit();
}
	
/* ------------------------------------------------------------------------ */

function do_compare() {
	// Compare two lists

	prepare_list_control_form();

	prepare_list_options();

	var f = window.document.list_control;

	f.target = "List" + wn++;
	f.action = Compare_Prog;

	open_list("", f.target);
	f.submit();
}
	
/* ------------------------------------------------------------------------ */

function do_log(url) {
	// Enter log message for all selected list records

	prepare_list_control_form();

	var f = window.document.list_control;

	f.target = "List" + wn++;
	if (url) { f.action = url } else { f.action = Log_Prog }

	open_log("", f.target);
	f.submit();
}
	
/* ------------------------------------------------------------------------ */

function do_export(url) {
	// Export a list

	prepare_list_control_form();

	var f = window.document.list_control;

	selectList(f.columns);		// list of columns to export
	selectList(f.sort_columns);	// sort order of export

	f.target = "List" + wn++;
	if (url) { f.action = url } else { f.action = Export_Prog }

	var settings = "menubar,resizable,scrollbars,status" +
	  ",width=600,height=400";

	open_window("", f.target, settings);
	f.submit();
}
	
/* ------------------------------------------------------------------------ */

function do_email(url) {
	// Email to a list

	prepare_list_control_form();

	var f = window.document.list_control;

	f.target = "List" + wn++;
	if (url) { f.action = url } else { f.action = Email_Prog }

	var settings = "menubar,resizable,scrollbars,status" +
	  ",width=600,height=500";

	open_window("", f.target, settings);
	f.submit();
}
	
/* ------------------------------------------------------------------------ */

function do_edit(url) {
	// Edit list

	prepare_list_control_form();

	var f = window.document.list_control;

	f.target = "List" + wn++;
	if (url) { f.action = url } else { f.action = Edit_Prog }

	open_form("", f.target);
	f.submit();
}
	
/* ------------------------------------------------------------------------ */
/*                                                                          */
/* Browse for files on the server.                                          */
/*                                                                          */
/* ------------------------------------------------------------------------ */

var browse_args = new Object;		// Saved arguments for browse_return()

function browse_lists(list, func) {
	// Open browse window.
	var url = Browse_Prog + "?lists="+ escape(list);
	var window_name = "w_" + list;

	// Save arguments for return
	browse_args[window_name] = func;

	// Open pop-up window
	open_browse(url,window_name);
	return true;
}

function browse_reports(report, func) {
	// Open browse window.
	var url = Browse_Prog + "?reports="+ escape(report) + "&reports=/" + "&title=Reports";
	var window_name = "w_" + report;

	// Save arguments for return
	browse_args[window_name] = func;

	// Open pop-up window
	open_browse(url,window_name);
	return true;
}

function browse_return(window_name,file_name) {
	var func = browse_args[window_name];

	if (!file_name) return false;	// no return value
	if (!func) return false;	// no return function

	func(file_name);

	return true;
}

/* ------------------------------------------------------------------------ */
/*                                                                          */
/* List Utilities                                                           */
/*                                                                          */
/* ------------------------------------------------------------------------ */

var prev_flip = { "id" : void 0 };

function flip(e) {

	// Exclude / include record in export list
	// The class name of e is used as a flag determining whether to
	// include or exclude the name from the export list. 

	if (window.event && window.event.shiftKey) {

		if (prev_flip.id) {
			// Use the current state of the last flipped to see if
			// the items between should be "checked" or "unchecked".

			var set_check = false;
			if (e.className != "checked") set_check = true;

			flip_between(e,prev_flip,set_check);
		}
		else {
			// Shift key depressed on first click.
			// Just act like a regular click.
			flip_e(e);
			prev_flip = e;
		}

		display_summary();

		// Set returnValue to false to avoid a new window
		// popping up as that's what usuall happens in IE when
		// holding a shift key down when clicking a link.

		window.event.returnValue = false;
		return;
	}

	flip_e(e);
	prev_flip = e;

	display_summary();
}

/* ------------------------------------------------------------------------ */

function flip_e(e) {

	// Extract row's key value from my Id attribute.
	var keyval = e.id.replace(/^l_/,"");

	var inverted = false;
	if (document.list_control.invert_all.value == "yes") inverted = true;

	if (e.className == "checked") {
		e.className = "unchecked";

		nchecked--;
		nunchecked++;

		if (!inverted) exclude_key(keyval);
		else           include_key(keyval);

	} else if (e.className == "unchecked") {
		e.className = "checked";

		nchecked++;
		nunchecked--;

		if (!inverted) include_key(keyval);
		else           exclude_key(keyval);
	}
}

/* ------------------------------------------------------------------------ */

function flip_between(e, prev_e, set_check) {

	// Flip all links between the previous two elements.

	var i,l;
	for (i = 0; i < document.links.length; i++) {
		l = document.links[i];
		if (l.id == e.id || l.id == prev_e.id) break;
	}

	if (l.id && l.id.indexOf("l_") == 0) {
		if (set_check) {
			if (l.className != "checked") flip_e(l);
		}
		else {
			if (l.className == "checked") flip_e(l);
		}
	}

	for (i = i+1; i < document.links.length; i++) {
		l = document.links[i];

		if (l.id && l.id.indexOf("l_") == 0) {
			if (set_check) {
				if (l.className != "checked") flip_e(l);
			}
			else {
				if (l.className == "checked") flip_e(l);
			}

			if (l.id == e.id || l.id == prev_e.id) break;
		}
	}
}

/* ------------------------------------------------------------------------ */

function include_keys() {
	for (var i = 0; i < arguments.length; i++) {
		include_key(arguments[i]);
	}
}

/* ------------------------------------------------------------------------ */

function include_key(id) {

	// Delete from excluded_rows if found.

	var j;	// index
	var found = false;
	for (j=0; j <= excluded_rows.length; j++) {
		if (excluded_rows[j] == id) {
			excluded_rows[j] = null;
			nexcluded--;
			return;
		}
	}

	// Enter into the include list.
	if (nincluded < included_rows.length) {
		// First look for empty slot in include list.
		for (j=0; j <= included_rows.length; j++) {
			if (included_rows[j] == null) {
				included_rows[j] = id;
				nincluded++;
				return;
			}
		}
	}

	// Enter new slot into the include list.
	included_rows[included_rows.length+1] = id;
	nincluded++;
	return;
}

/* ------------------------------------------------------------------------ */

function exclude_keys() {
	for (var i = 0; i < arguments.length; i++) {
		exclude_key(arguments[i]);
	}
}

/* ------------------------------------------------------------------------ */

function exclude_key(id) {

	// Delete from included_rows if found.

	var j;	// index
	var found = false;
	for (j=0; j <= included_rows.length; j++) {
		if (included_rows[j] == id) {
			included_rows[j] = null;
			nincluded--;
			return;
		}
	}

	// Enter into the exclude list.
	if (nexcluded < excluded_rows.length) {
		// first look for empty slot in exclude list
		for (j=0; j <= excluded_rows.length; j++) {
			if (excluded_rows[j] == null) {
				excluded_rows[j] = id;
				nexcluded++;
				return;
			}
		}
	}

	// Enter into the exclude list.
	excluded_rows[excluded_rows.length+1] = id;
	nexcluded++;
	return;
}

/* ------------------------------------------------------------------------ */

function select_all() {

	clear_selector();

	// Set list parameters
	document.list_control.select_all.value = "yes";

	// Adjust counters.
	nchecked += nunchecked;
	nunchecked = 0;

	// Set all rows to "checked".
	var i, l;
	for (i = 0; i < document.links.length; i++) {
		l = document.links[i];

		// Look for links with a known prefix: l_
		if (l.id && l.id.indexOf("l_") == 0) {
			l.className = "checked";
		}
	}

	display_summary();
}

/* ------------------------------------------------------------------------ */

function invert_all() {

	// Exclude / include record in export list
	// The name of the image file is used as the flag whether to
	// include or exclude the name from the export list. 
	
	var fld = document.list_control.invert_all;
	if (fld.value == "yes") fld.value = "no"
	else                    fld.value = "yes";

	// Reset counters
	nchecked = 0;
	nunchecked = 0;

	var i, j;

	// Set all rows to "checked".
	for (i = 0; i < document.links.length; i++) {
		l = document.links[i];

		// Look for links with a known prefix: l_
		if (l.id && l.id.indexOf("l_") == 0) {
			if (l.className == "checked") {
				l.className = "unchecked";
				nunchecked++;
			}
			else if (l.className == "unchecked") {
				l.className = "checked";
				nchecked++;
			}
		}
	}

	display_summary();
}

/* ------------------------------------------------------------------------ */

function select_table(table_id) {
        // Select the table with the given table_id so that it can be copied and
	// pasted (or dragged and dropped) in another application like Excel.
        // Only works in Microsoft Internet Explorer.

        if (!document.all) return;
        if (!document.all[table_id]) return;

        var r = document.body.createTextRange();
        r.moveToElementText(document.all[table_id]);
        r.select();
}

/* ------------------------------------------------------------------------ */

function display_summary() {
        // Display number of checked and unchecked

        var f = document.list_summary;
	if (! f) return;
	f.n_checked.value = nchecked;
	f.n_unchecked.value = nunchecked;
}
