/*
 * AcmeMenu v2.4
 *
 * Copyright Mackley F. Pexton, 2003.  All rights reserved.
 *
 * This is free software for individual, educational, and non-profit use.
 * Instructions and source code are available at www.acmebase.org/menu.
 * Optimized version of software is for sale at order.acmebase.com.
 * Commercial web sites are required to have an inexpensive license.
 * This software is part of the AcmeBase project at www.acmebase.org.
 * Send correspondence and feedback to: mack@acmebase.org.
 */

/*
 * Detect Browser Version
 */

bv.isNS     = (navigator.userAgent.indexOf("Netscape") >= 0) ? true : false;

bv.isOpr    = (navigator.userAgent.indexOf("Opera")    >= 0) ? true : false;
bv.isOpr5   = (navigator.userAgent.indexOf("Opera 5")  >= 0) ? true : false;
bv.isOpr6   = (navigator.userAgent.indexOf("Opera/6")  >= 0) ? true : false;
bv.isOpr7   = (navigator.userAgent.indexOf("Opera/7")  >= 0) ? true : false;

bv.isIE     = (document.all && ! bv.isOpr);
bv.isIE6    = (bv.isIE && document.compatMode && document.compatMode.indexOf("CSS1") >= 0) ? true : false;
bv.isIE5Mac = (bv.isIE && navigator.userAgent.indexOf('Mac') >= 0) ? true : false;
bv.isIE5    = (bv.isIE && ! bv.isIE5Mac && ! bv.isIE6) ? true : false;

bv.isMoz    = (! bv.isNS && ! bv.isOpr && ! bv.isIE && navigator.userAgent.indexOf("Mozilla") == 0) ? true : false;

function bv() {
	var s = "";
	for (var v in bv) if (v.substring(0,2) == "is" && bv[v]) s += (s ? " " : "") + v;
	return s;
}

/*
 * Main Functions
 */

function make_menu(id, header_id, keep_open) {

	

	var m;

	if (Menu.menus[id]) {

		

		for (var menu_id in Menu.menus) {
			m = Menu.menus[menu_id];
			if (m.top.id == id) {
				m.hide_menu();
				delete Menu.menus[menu_id];
			}
		}
	}

	var manual    = false;
	keep_open = (keep_open != null && keep_open) ? true : Menu.KeepOpen;

	m = new Menu(id, header_id, manual, keep_open);

	m.configure_menu();

	var header_e = m.header_e;

	if (header_e) {

		if (header_e.onmouseover && header_e.onmouseover != Menu.onmouseover_handler)
			header_e.orig_onmouseover = header_e.onmouseover;
		if (header_e.onmouseout && header_e.onmouseout != Menu.onmouseout_handler)
			header_e.orig_onmouseout = header_e.onmouseout;
	
		header_e.onmouseover = Menu.onmouseover_handler;
		header_e.onmouseout  = Menu.onmouseout_handler;

		if (bv.isNS) Menu.set_enclosed_elements_handler(header_e);
	}
	else {

		m.setup_menu();
	}
	if (document.body.onclick && document.body.onclick != Menu.onclick_body_handler)
		Menu.orig_onclick_body_handler = document.body.onclick;
	document.body.onclick = Menu.onclick_body_handler;
	if (window.onresize && window.onresize != Menu.onresize_handler)
		Menu.orig_onresize_handler = window.onresize;
	window.onresize = Menu.onresize_handler;
	
	return m;
}

function menu(id, header_id, keep_open) {
	var m = Menu.menus[id];
	if (!m) {
		if (! getElementRef(id)) {
			
			return;
		}

		var manual = true;
		keep_open = keep_open ? true : false;

		m = new Menu(id, header_id, manual, keep_open);

		m.configure_menu();
		
		Menu.build_submenus(m, getElementRef(id));
	}

	if (! m.header_e) {
		return;
	}
	if (m.keep_open && ! m.manual) return;
	if (m.is_visible) {

		if (m.manual || m.ClickStop) {
			if (m.click_stop_auto_set) m.ClickStop = false;
			m.hide_submenu();
		}
		else {
			m.ClickStop = true;
			m.click_stop_auto_set = true;
			m.show_menu();
			Menu.click_stop_menu = m;
		}
	}
	else {
		m.show_menu();
	}
}

function submenu(id) {

	

	var m = Menu.menus[id];

	if (m) {
		if (! m.manual) return;

		if (m.is_visible) { m.hide_submenu(); }
		else {
			if (m.parent.child) m.parent.hide_submenu();
			m.parent.show_submenu(id);
		}

		return;
	}

	
}

function hide_menus(force_relocation) {

	

	var m;
	for (var id in Menu.menus) {
		m = Menu.menus[id];
		if (! m.keep_open) m.hide_menu();
		if (force_relocation) m.is_located = false;
	}

	Menu.click_start_enabled = false;
}

function reset_menus() {

/*
 * Menu Settings
 */
Menu.MenuOffsetX = 0;
Menu.MenuOffsetY = 0;
Menu.SubmenuOffsetX = 0;
Menu.SubmenuOffsetY = 0;
Menu.MenuPosition    = "D";
Menu.SubmenuPosition = "R";
Menu.AllowReposition = true;
Menu.MenuOrientation    = "V";
Menu.SubmenuOrientation = "V";
Menu.BodyMarginTop = 0;
Menu.ClickStart = false;
Menu.ClickStop = Menu.ClickStart || false;
Menu.KeepOpen = false;
Menu.AutoHideTime = 0;
Menu.FadeDuration = 0;
Menu.ShowFadeDuration = 0;
Menu.HideFadeDuration = 0;
Menu.FadeSpeed = 0;
Menu.ShowFadeSpeed = 0;
Menu.HideFadeSpeed = 0;
Menu.FadePercent = 10;
Menu.ShowFadePercent = 0;
Menu.HideFadePercent = 0;

Menu.Trigger = null;
Menu.ShowTrigger = null;
Menu.HideTrigger = null;
Menu.AllowFreeze = true;
Menu.CacheLocation = true;
Menu.MenuFixed = false;
Menu.SubmenuFixed = false;
Menu.ZIndex = 1000;
Menu.HighlightSuffix = "-hilite";
Menu.TimeToShow = 150;
Menu.TimeToHide = 100;

}

reset_menus();
Menu.menus = {};
Menu.click_start_enabled = false;
Menu.click_stop_menu = null;
Menu.keep_open_menu = null;
Menu.frozen_menu = null;
Menu.auto_hide_timer = null;
Menu.max_z = 0;
Menu.menu_re    = /menu\(\s*(['"]?)([^'",)]+)/;
Menu.submenu_re = /submenu\(\s*(['"]?)([^'",)]+)/;

/*
 * Menu Object Definition
 */

function Menu(id, header, manual, keep_open) {
	
	

	if (id) this.e = getElementRef(id);
	if (header) this.header_e = getElementRef(header);

	if (! this.e) {
		
	}
	if (header && ! this.header_e) {
		
	}

	this.id			= id;

	this.is_submenu		= false;
	this.is_setup		= false;
	this.is_located		= false;
	this.is_finalized	= false;
	this.is_fixed		= false;
	this.is_static		= this.header_e ? false : true;
	this.is_visible		= this.is_static ? true : false;

	this.parent		= null;
	this.child		= null;
	this.top		= this;

	this.x			= null;
	this.y			= null;
	this.z			= Menu.ZIndex;

	this.evt		= null;

	this.frozen_e		= null;
	this.frozen_onmouseout	= null;
	this.saved_body_onclick	= null;

	this.show_timer		= 0;
	this.hide_timer		= 0;

	this.opacity		= 0;
	this.show_fade_timer	= 0;
	this.hide_fade_timer	= 0;

	this.manual		= manual;
	this.keep_open		= keep_open;
	Menu.menus[id] = this;
}

/*
 * Event Handlers
 */

Menu.onmouseover_handler = function(evt) {
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var e = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;

	

	clearTimeout(Menu.auto_hide_timer);
	var menu_id, submenu_id, submenu_target;	
	var m;
	for (var target = e; target != null; target = target.parentNode) {
		if (target.orig_onmouseover) target.orig_onmouseover(evt);

		if (target.id && (m = Menu.menus[target.id])) {

			if (Menu.frozen_menu
			&& Menu.frozen_menu.e != target) Menu.frozen_menu.thaw();

			m.save_event(evt);
			if (m.child && (! submenu_id || m.child.id != submenu_id)) {
				m.child.hide_submenu();
			}
			if (m.is_static) m.hide_opened_menus();

			if (submenu_id) { m.show_submenu(submenu_id,submenu_target); }
			else            { m.show_menu(); }

			break;
		}

		if (target.href) {
			if (target.href.match(Menu.submenu_re)) {
				submenu_id = RegExp.$1 ? RegExp.$2 : eval(RegExp.$2);
				submenu_target = target;
				continue;
			}

			if (target.href.match(Menu.menu_re)) {
				menu_id = RegExp.$1 ? RegExp.$2 : eval(RegExp.$2);

				

				if (Menu.frozen_menu) Menu.frozen_menu.thaw();

				if ((m = Menu.menus[menu_id])) {

					if (! m.is_located) m.save_event(evt);
					if (m.ClickStart && ! Menu.click_start_enabled) {
						
						break;
					}
					m.hide_opened_menus();

					m.show_menu();
				}

				break;
			}
		}
	}
}

Menu.onmouseout_handler = function(evt) {
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var e = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;

	if (bv.isNS) {
		if (e.nodeName == "TEXTAREA") return;
		if (e.nodeName == "OPTION") return;
	}
	var m, top;
	var menu_id, submenu_id;
	for (var target = e; target != null; target = target.parentNode) {
		if (target.orig_onmouseout) target.orig_onmouseout(evt);

		if (target.id && (m = Menu.menus[target.id])) {
			if (m.keep_open) break;
			top = m.top;
			if (top.ClickStop) {
				if (top.click_stop_auto_set) top.ClickStop = false;
				if (top.AutoHideTime) {
					

					Menu.auto_hide_timer = setTimeout(
					  "hide_menus()", top.AutoHideTime);
				}
				break;
			}
			m.hide_submenu();
			while ((m = m.parent)) {
				m.hide_menu();
			}

			break;
		}

		if (target.href) {

			if (target.href.match(Menu.submenu_re)) {
				submenu_id = RegExp.$1 ? RegExp.$2 : eval(RegExp.$2);
				continue;
			}

			if (target.href.match(Menu.menu_re)) {
				menu_id = RegExp.$1 ? RegExp.$2 : eval(RegExp.$2);

				

				if ((m = Menu.menus[menu_id])) {
					if (m.ClickStop || m.keep_open) {
						if (m.AutoHideTime) {
							

							Menu.auto_hide_timer = setTimeout(
							  "hide_menus()", m.AutoHideTime);
						}

						

						break;
					}

					m.hide_submenu();
				}

				break;
			}
		}
	}
}

Menu.onclick_handler = function(evt) {
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var e = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;
	var m;
	for (var target = e; target != null; target = target.parentNode) {

		if (target.href
		&& target.nodeName == "A"
		&& ! target.href.match(Menu.submenu_re)) {
			hide_menus();
			break;
		}

		if (! target.onclick) continue;

		if (target.orig_onclick) target.orig_onclick(evt);

		if (target.id && (m = Menu.menus[target.id])) {

			m.freeze();
			break;
		}
	}

	evt.cancelBubble = true;
	if (evt.stopPropagation) evt.stopPropagation();

	return true;
}

Menu.onclick_handler_ignore = function(evt) {
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var e = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;

	

	if (e.orig_onclick) e.orig_onclick(evt);

	evt.cancelBubble = true;
	if (evt.stopPropagation) evt.stopPropagation();
	return true;
}

Menu.onclick_body_handler = function(evt) {

	

	hide_menus();
	if (Menu.orig_onclick_body_handler) return Menu.orig_onclick_body_handler(evt);
}

Menu.onresize_handler = function(evt) {

	

	hide_menus('relocate');
	if (Menu.orig_onresize_handler) return Menu.orig_onresize_handler(evt);
}

/*
 * Freezing methods
 */
Menu.onclick_body_handler_thaw = function(evt) {

	

	if (Menu.frozen_menu) Menu.frozen_menu.thaw();
}

Menu.prototype.freeze = function() {

	

	if (Menu.frozen_menu) {
		if (Menu.frozen_menu == this) {
			return;	
		}
		else {
			Menu.frozen_menu.thaw();
		}
	}

	this.frozen_e = this.e;
	this.frozen_onmouseout   = this.frozen_e.onmouseout;
	this.frozen_e.onmouseout = null;

	this.saved_body_onclick = document.body.onclick;
	document.body.onclick = Menu.onclick_body_handler_thaw;

	Menu.frozen_menu = this;
	if (bv.isMoz) this.show_menu();
}

Menu.prototype.thaw = function() {

	

	if (this.frozen_e) {
		this.frozen_e.onmouseout = this.frozen_onmouseout;
		document.body.onclick    = this.saved_body_onclick;
	}

	this.frozen_e = null;

	Menu.frozen_menu = null;
	var m = this;
	do {
		

		m.hide_menu();
	} while ((m = m.parent));
}

/*
 * Menu builder
 */
Menu.filter_object = {
	"#text":	true,
	"SELECT":	true,
	"TEXTAREA":	true};

Menu.build_submenus = function(m,e) {

	

	if (e.href && e.href.match(Menu.submenu_re)) {

		var id = RegExp.$1 ? RegExp.$2 : eval(RegExp.$2);

		var submenu = m.make_submenu(id,e);
		Menu.build_submenus(submenu, getElementRef(id));

		

		return;
	}

	if (e.childNodes) {

		for (var n = 0; n < e.childNodes.length; n++) {

			if (! Menu.filter_object[e.childNodes[n].nodeName]) {

				

				Menu.build_submenus(m, e.childNodes[n]);
			}
		}
	}

	
}

Menu.set_enclosed_elements_handler = function(e) {

	var child_e;

	if (e.childNodes) {

		for (var n = 0; n < e.childNodes.length; n++) {

			child_e = e.childNodes[n];

			if (child_e.nodeType != 1) continue;
			if (child_e.onmouseover
			&& child_e.onmouseover != Menu.onmouseover_handler)
				child_e.orig_onmouseover = child_e.onmouseover;

			child_e.onmouseover = Menu.onmouseover_handler;

			
		}
	}
}

Menu.prototype.make_submenu = function(menu_id, header) {

	var submenu = new Menu(menu_id, header, this.manual, this.keep_open);
	submenu.parent = this;
	submenu.top    = this.top;
	submenu.is_submenu = true;
	submenu.z = this.z + 10;
	
	return submenu;
}

Menu.prototype.configure_menu = function() {

	var v,c;
	for (v in Menu) {
		c = v.substr(0,1);
		if (c == c.toUpperCase()) {

			this[v] = Menu[v];
		}
	}
}


Menu.prototype.setup_menu = function() {

	if (! this.e) return;

	if (this.manual) {

		this.is_located   = true;
		this.is_finalized = true;

		this.e.style.zIndex = 100;

		this.AllowReposition = false;

		if (document.body.onclick && ! this.e.onclick) {
			this.e.onclick = Menu.onclick_handler_ignore;
		}
	}
	else {
		if (! this.is_submenu) this.setup_top_menu();
		if (this.header_e && this.header_e.href.match(/;\s*(.*)/)) {
			this.trigger_str = RegExp.$1;
		}

		if (this.trigger_str || this.top.has_show_trigger) this.has_show_trigger = true;
		if (this.trigger_str || this.top.has_hide_trigger) this.has_hide_trigger = true;
		this.is_fixed = this.is_submenu
			      ? (this.top.SubmenuFixed || false)
			      : (this.top.MenuFixed || false);
		if (this.e.onmouseover && this.e.onmouseover != Menu.onmouseover_handler)
			this.e.orig_onmouseover = this.e.onmouseover;
		if (this.e.onmouseout && this.e.onmouseout != Menu.onmouseout_handler)
			this.e.orig_onmouseout  = this.e.onmouseout;
		if (this.e.onclick && this.e.onclick != Menu.onclick_handler)
			this.e.orig_onclick     = this.e.onclick;
		this.e.onmouseover = Menu.onmouseover_handler;
		this.e.onmouseout  = Menu.onmouseout_handler;
		if (this.top.AllowFreeze) this.e.onclick = Menu.onclick_handler;

		if (bv.isNS) Menu.set_enclosed_elements_handler(this.e);
	}

	this.is_setup = true;
}

Menu.prototype.setup_top_menu = function() {

	if (this.ClickStart) this.ClickStop = true;

	if (this.AutoHideTime) {
		this.AutoHideTime = parseFloat(this.AutoHideTime) * 1000.0;
		this.ClickStop = true;
	}
	if (this.ShowTrigger || this.Trigger) this.has_show_trigger = true;
	if (this.HideTrigger || this.Trigger) this.has_hide_trigger = true;
	if (bv.isIE5Mac || bv.isOpr) {
		this.show_fade_duration = this.hide_fade_duration = 0;
		return;
	}

	this.show_fade_duration = this.ShowFadeDuration
				? this.ShowFadeDuration
				: this.FadeDuration
				? this.FadeDuration
				: 0;

	this.hide_fade_duration = this.HideFadeDuration
				? this.HideFadeDuration
				: this.FadeDuration
				? this.FadeDuration
				: 0;

	if (! this.show_fade_duration && ! this.hide_fade_duration) return;

	this.show_fade_speed	= this.ShowFadeSpeed
				? this.ShowFadeSpeed
				: this.FadeSpeed
				? this.FadeSpeed
				: this.ShowFadePercent
				? Math.ceil(this.show_fade_duration * this.ShowFadePercent/100)
				: this.FadePercent
				? Math.ceil(this.show_fade_duration * this.FadePercent/100)
				: Math.ceil(this.show_fade_duration * 10/100);

	this.hide_fade_speed	= this.HideFadeSpeed
				? this.HideFadeSpeed
				: this.FadeSpeed
				? this.FadeSpeed
				: this.HideFadePercent
				? Math.ceil(this.hide_fade_duration * this.HideFadePercent/100)
				: this.FadePercent
				? Math.ceil(this.hide_fade_duration * this.FadePercent/100)
				: Math.ceil(this.hide_fade_duration * 10/100);
	
	this.show_fade_percent	= this.show_fade_speed / this.show_fade_duration * 100;
	this.hide_fade_percent	= this.hide_fade_speed / this.hide_fade_duration * 100;
}

Menu.prototype.locate_menu = function() {

	

	if (this.evt) {
		if (this.is_submenu)	{ this.compute_position_submenu(); }
		else			{ this.compute_position_menu();    }

		var fudge = bv.isIE5 ? -2 : 0;
		this.e.style.left = (this.x + fudge) + "px";
		this.e.style.top  = (this.y + fudge) + "px";
		if (bv.isOpr5) this.e.style.pixelTop  = (this.y + fudge);

		
	}

	this.e.style.zIndex  = this.z;

	if (this.top.CacheLocation
	&& (! this.parent || this.parent.is_located))
		this.is_located = true;
	this.is_finalized = false;
}

Menu.prototype.locate_static_menu = function(submenu) {

	this.x = getEventElementLeft(submenu.evt, this.e, 
				this.get_border_width("left"),
				this.get_padding("left"));

	this.is_located = true;
}

Menu.prototype.finalize_menu = function() {

	if (! this.e) return;

	this.is_finalized = true;

	if (this.manual) return;

	if (this.is_submenu) {
		if (this.top.SubmenuPosition == "R") return;

		this.finalize_position_submenu();
	}
	else {
		if (this.top.MenuPosition == "D") return;

		this.finalize_position_menu();   
	}

	var fudge = bv.isIE5 ? -2 : 0;
	this.e.style.left = (this.x + fudge) + "px";
	this.e.style.top  = (this.y + fudge) + "px";
	if (bv.isOpr5) this.e.style.pixelTop  = this.y;

	
}

Menu.prototype.save_event = function(evt) {

	this.evt = {
		"target"  : (evt.target ? evt.target : evt.srcElement ? evt.srcElement : null),

		"offsetX" : (evt.offsetX ? evt.offsetX : 0),
		"offsetY" : (evt.offsetY ? evt.offsetY : 0),
		"clientX" : (evt.clientX ? evt.clientX : 0),
		"clientY" : (evt.clientY ? evt.clientY : 0) };
}

/*
 * Showing methods
 */

Menu.prototype.show_menu = function() {

	

	clearTimeout(this.hide_timer);
	clearTimeout(this.show_timer);

	if (this.is_submenu) this.show_parentmenu();

	if (this.is_static) this.track_shown_open_menus();

	if (this.is_visible) return;
	this.show_timer = setTimeout("Menu.now_show_menu('"+this.id+"')", this.top.TimeToShow);

	
}
Menu.now_show_menu = function(menu_id) {

	

	var m = Menu.menus[menu_id];
	if (m) m.do_show_menu();
}

Menu.prototype.do_show_menu = function() {

	

	if (! this.e) {
		
		return;
	}

	if (this.is_visible) return;
	if (this.top.ClickStop && this.parent && ! this.parent.is_visible) return;

	if (! this.is_setup) this.setup_menu();

	if (! this.is_fixed
	&& (! this.is_located || (this.parent && ! this.parent.is_located))) this.locate_menu();
	if (this.top.show_fade_duration) {
		this.show_menu_fade();
	}
	else {
		this.e.style.display = "block";
		this.e.style.visibility = "visible";

		if (this.top.hide_fade_duration) {
			this.opacity = 100;
			this.show_menu_fade();
		}
	}

	if (! this.is_fixed) {

		if (! this.is_finalized) this.finalize_menu();

		if (this.top.AllowReposition) this.reposition_menu();
	}
	if (this.header_e.className) {
		this.header_e.className += this.top.HighlightSuffix;
	}

	this.is_visible = true;

	if (! this.is_submenu && ! this.manual) this.track_shown_open_menus();
	if (this.has_show_trigger) setTimeout("Menu.now_show_trigger('"+this.id+"')", 1);
}

/*
 * Hiding methods
 */

Menu.prototype.hide_menu = function() {

	

	clearTimeout(this.hide_timer);
	clearTimeout(this.show_timer);

	if (this.is_static) this.track_hidden_open_menus();

	if (! this.is_visible) return;
	this.hide_timer = setTimeout("Menu.now_hide_menu('"+this.id+"')", this.top.TimeToHide);

	
}
Menu.now_hide_menu = function(menu_id) {

	

	var m = Menu.menus[menu_id];
	if (m) m.do_hide_menu();
}

Menu.prototype.do_hide_menu = function() {

	

	if (! this.is_visible || this.is_static) return;
	if (this.top.hide_fade_duration) {
		this.hide_menu_fade();
	}
	else {
		this.e.style.visibility = "hidden";
		this.e.style.display = "none";

		if (this.top.show_fade_duration) {
			this.opacity = 0;
			this.hide_menu_fade();
		}
	}
	if (this.header_e.className) {
		var re = new RegExp(this.top.HighlightSuffix);
		this.header_e.className = this.header_e.className.replace(re,"");
	}

	this.is_visible = false;

	if (! this.is_submenu && ! this.manual) this.track_hidden_open_menus();
	if (this.has_hide_trigger) setTimeout("Menu.now_hide_trigger('"+this.id+"')", 1);
}

/*
 * Fading methods
 */

Menu.prototype.show_menu_fade = function() {

	

	clearTimeout(this.show_fade_timer);
	clearTimeout(this.hide_fade_timer);
	if (this.z > Menu.max_z) { Menu.max_z = this.z; }
	else			 { this.e.style.zIndex = ++Menu.max_z; }
		
	this.e.style.display = "block";
	this.e.style.visibility = "visible";

	Menu.now_show_menu_fade(this.id);
}
Menu.now_show_menu_fade = function(menu_id) {

	

	var m = Menu.menus[menu_id];
	if (m) {
		m.opacity += m.top.show_fade_percent;
		if (m.opacity > 100) m.opacity = 100;

		m.do_menu_fade();

		if (m.opacity < 100) {
			m.show_fade_timer = setTimeout(
			  "Menu.now_show_menu_fade('"+menu_id+"')",
			  m.top.show_fade_speed);
		}
	}
}

Menu.prototype.hide_menu_fade = function() {

	

	clearTimeout(this.show_fade_timer);
	clearTimeout(this.hide_fade_timer);

	Menu.now_hide_menu_fade(this.id);
}
Menu.now_hide_menu_fade = function(menu_id) {

	

	var m = Menu.menus[menu_id];
	if (m) {
		m.opacity -= m.top.hide_fade_percent;
		if (m.opacity < 0) m.opacity = 0;

		m.do_menu_fade();

		if (m.opacity > 0) {
			m.hide_fade_timer = setTimeout(
			  "Menu.now_hide_menu_fade('"+menu_id+"')",
			  m.top.hide_fade_speed);
		}
		else {
			m.e.style.visibility = "hidden";
			m.e.style.display = "none";
		}
	}
}

Menu.prototype.do_menu_fade = function() {

	if (bv.isIE5 || bv.isIE6) {
		this.e.style.filter =
		  "progid:DXImageTransform.Microsoft.Alpha(opacity="+this.opacity+")";
	}
	else if (bv.isNS || bv.isMoz) {
		this.e.style.MozOpacity = this.opacity + '%';
	}
}

/*
 * Sub-menu methods
 */

Menu.prototype.show_submenu = function(menu_id,header) {

	

	var submenu = Menu.menus[menu_id];
	if (! submenu) submenu = this.make_submenu(menu_id,header);
	this.child = submenu;
	submenu.evt = this.evt;

	submenu.show_menu();
}

Menu.prototype.hide_submenu = function() {
	if (this.child) this.child.hide_submenu();

	this.hide_menu();
}

/*
 * Parent-menu methods
 */

Menu.prototype.show_parentmenu = function() {

	

	var m, child = this;

	while ((m = child.parent)) {

		

		m.show_menu();

		if (m.child && m.child != child) m.child.hide_submenu();

		m.child = child;

		child = m;
	}
}

/*
 * Open menu methods
 */

Menu.prototype.hide_opened_menus = function() {
	if (Menu.click_stop_menu && Menu.click_stop_menu != this.top)
		Menu.click_stop_menu.hide_submenu();
	if (this.keep_open
	&& Menu.keep_open_menu && Menu.keep_open_menu != this.top)
		Menu.keep_open_menu.hide_submenu();
}

Menu.prototype.track_shown_open_menus = function() {

	

	if (this.ClickStop) {
		if (Menu.click_stop_menu && Menu.click_stop_menu != this) {
			Menu.click_stop_menu.do_hide_menu();
		}

		Menu.click_stop_menu = this;
		Menu.click_start_enabled = true;

		
	}

	if (this.keep_open) {
		if (Menu.keep_open_menu && Menu.keep_open_menu != this) {
			Menu.keep_open_menu.do_hide_menu();
		}

		Menu.keep_open_menu = this;
		Menu.click_start_enabled = false;

		
	}
}

Menu.prototype.track_hidden_open_menus = function() {

	

	if (Menu.click_stop_menu && Menu.click_stop_menu == this) {

		

		if (this.click_stop_auto_set) this.ClickStop = false;

		Menu.click_stop_menu = null;
	}

	if (Menu.keep_open_menu && Menu.keep_open_menu == this) {

		

		Menu.keep_open_menu = null;
	}
}

/*
 * Trigger methods
 */
Menu.now_show_trigger = function(menu_id) {

	

	var m = Menu.menus[menu_id];
	if (!m) return;
	
	if (m.top.ShowTrigger) m.top.ShowTrigger(m);
	if (m.top.Trigger) m.top.Trigger(m);
	if (m.trigger_str) eval(m.trigger_str);
}
Menu.now_hide_trigger = function(menu_id) {

	

	var m = Menu.menus[menu_id];
	if (!m) return;

	if (m.top.HideTrigger) m.top.HideTrigger(m);
	if (m.top.Trigger) m.top.Trigger(m);
	if (m.trigger_str) eval(m.trigger_str);
}


/*
 * Positioning methods
 */

Menu.prototype.compute_position_menu = function() {

	this.x	= getEventElementLeft(this.evt, this.header_e,
			this.get_header_border_width("left"),
			this.get_header_padding("left")) +
		  this.top.MenuOffsetX;

	this.y	= this.get_header_top() +
		  this.get_header_height() +
		  this.top.MenuOffsetY;

	
}

Menu.prototype.compute_position_submenu = function() {

	var parent = this.parent;

	if (parent.is_static && ! parent.is_located) parent.locate_static_menu(this);

	this.x	= (this.top.SubmenuOrientation == "V" && this.top.MenuOrientation == "V"
		? parent.x +
		  getElementWidth(parent.e, parent.getBorderWidth())
		: getEventElementLeft(this.evt, this.header_e,
			this.get_header_border_width("left"),
			this.get_header_padding("left")) +
		  getElementWidth(this.header_e, this.getHeaderBorderWidth())
		  ) +
		  this.top.SubmenuOffsetX;

	this.y	= (this.top.SubmenuOrientation != "N"
		? this.compute_vert_menu_y()
		: this.get_header_top()
		  ) +
		  this.top.SubmenuOffsetY;

	
}

Menu.prototype.finalize_position_menu = function() {

	

	switch (this.top.MenuPosition) {
	case "U":
		this.y -= getElementHeight(this.e) +
			  this.get_header_height() +
			  this.top.MenuOffsetY * 2;
		break;

	case "L":
		this.x -= getElementWidth(this.e, this.getBorderWidth()) +
			  this.top.MenuOffsetX * 2;

		this.y	= this.get_header_top() +
			  this.top.MenuOffsetY;
		break;

	case "R":
		this.x += getElementWidth(this.header_e, this.getHeaderBorderWidth());
		this.y	= this.get_header_top() +
			  this.top.MenuOffsetY;
		break;

	case "D":
	default:
	}
}

Menu.prototype.finalize_position_submenu = function() {

	

	switch (this.top.SubmenuPosition) {
	case "L":
		this.x	= (this.top.SubmenuOrientation == "V" && this.top.MenuOrientation == "V"
			? this.parent.x
			: getEventElementLeft(this.evt, this.header_e,
				this.get_header_border_width("left"),
				this.get_header_padding("left"))
			  ) -
			  getElementWidth(this.e, this.getBorderWidth()) -
			  this.top.SubmenuOffsetX;
		break;

	case "D":
		this.x	= (this.top.SubmenuOrientation != "N"
			? this.compute_horz_menu_x()
			: getEventElementLeft(this.evt, this.header_e,
				this.get_header_border_width("left"),
				this.get_header_padding("left"))
			  ) +
			  this.top.SubmenuOffsetX;

		this.y	= (this.top.SubmenuOrientation == "H" && this.top.MenuOrientation == "H"
			? this.parent.y +
			  getElementHeight(this.parent.e, this.parent.getBorderHeight())
			: this.get_header_top() +
			  this.get_header_height()
			  ) +
			  this.top.SubmenuOffsetY;
		break;

	case "U":
		this.x	= (this.top.SubmenuOrientation != "N"
			? this.compute_horz_menu_x()
			: getEventElementLeft(this.evt, this.header_e,
				this.get_header_border_width("left"),
				this.get_header_padding("left"))
			  ) +
			  this.top.SubmenuOffsetX;

		this.y	= (this.top.SubmenuOrientation == "H" && this.top.MenuOrientation == "H"
			? this.parent.y
			: this.get_header_top()
			  ) -
			  getElementHeight(this.e, this.getBorderHeight()) -
			  this.top.SubmenuOffsetY;
		break;

	case "R":
	default:
	}
}

Menu.prototype.reposition_menu = function() {

	var e = this.e;
	var b = document.body;
	var wright  = b.scrollLeft + (b.clientWidth  ? b.clientWidth  : b.offsetWidth);
	var wbottom = b.scrollTop  + (b.clientHeight ? b.clientHeight : b.offsetHeight);
	var eleft   = e.offsetLeft;
	var etop    = e.offsetTop;
	var eright  = eleft + e.offsetWidth;
	var ebottom = etop  + e.offsetHeight;
	var reposition = false;

	if (eright > wright) {
		eleft = wright - e.offsetWidth;
		reposition = true;
	}

	if (ebottom > wbottom) {
		etop = wbottom - e.offsetHeight;
		reposition = true;
	}

	if (eleft < b.scrollLeft) {
		eleft = b.scrollLeft;
		reposition = true;
	}

	if (etop < b.scrollTop) {
		etop = b.scrollTop;
		reposition = true;
	}

	if (reposition) {
		this.e.style.left = eleft + "px";
		this.e.style.top  = etop  + "px";
		if (bv.isOpr5) this.e.style.pixelTop  = etop;
		this.is_located = false;

		
	}
}

Menu.prototype.compute_horz_menu_x = function() {

	return getEventElementLeft(this.evt, this.header_e,
				this.get_header_border_width("left"),
				this.get_header_padding("left")) -
		 tableOffset(this.e) -
		 this.get_padding("left") -
		 this.get_border_width("left");
}

Menu.prototype.compute_vert_menu_y = function() {

	return this.get_header_top() -
		 tableOffset(this.e) -
		 this.get_padding("top") -
		 this.get_border_width("top");
}

Menu.prototype.get_header_top = function() {
	
	var header_e = this.header_e;

	if (bv.isIE) {

		return getEventElementTop(this.evt, header_e,
					this.get_header_border_width("top"),
					this.get_header_padding("top"));
	}

	if ( ((bv.isOpr5 || bv.isOpr6) && this.evt.target.toString().indexOf("HTMLImage") > 0)
	|| (this.evt.target.nodeName == "IMG"
	&& (getElementStyle(header_e,"display") == "inline")) ) {

		

		var iy = getEventElementTop(this.evt);
		var hy = getEventElementTop(this.evt, header_e);
		return iy < hy ? iy : hy;
	}

	return getEventElementTop(this.evt, header_e);
}

Menu.prototype.get_header_height = function() {

	if (bv.isIE) return getElementHeight(this.header_e);

	if ( ((bv.isOpr5 || bv.isOpr6) && this.evt.target.toString().indexOf("HTMLImage") > 0)
	|| (this.evt.target.nodeName == "IMG"
	&& (bv.isOpr7 || getElementStyle(this.header_e,"display") == "inline")) ) {

		

		var ih = getElementHeight(this.evt.target);
		var hh = getElementHeight(this.header_e);
		return ih > hh ? ih : hh;
	}

	return getElementHeight(this.header_e);
}

/*
 * Style properties
 */

Menu.prototype.get_border_width = function(position) {

	var width = getBorderWidth(this.e,position);

	if (getBorderWidth.found) return width;

	if (this.is_submenu && this.top.SubmenuBorderWidth != null)
		return this.top.SubmenuBorderWidth;

	if (this.top.MenuBorderWidth != null)
		return this.top.MenuBorderWidth;

	return 0;
}

Menu.prototype.get_header_border_width = function(position) {

	var width = getBorderWidth(this.header_e,position);
	if (getBorderWidth.found) return width;

	if (this.is_submenu) {
		if (this.top.SubmenuHeaderBorderWidth != null)
			return this.top.SubmenuHeaderBorderWidth;
	}
	else {
		if (this.top.MenuHeaderBorderWidth != null) 
			return this.top.MenuHeaderBorderWidth;
	}
	return 0;
}

Menu.prototype.get_padding = function(position) {

	var padding = getPadding(this.e,position);

	if (getPadding.found) return padding;

	if (this.is_submenu) {
		if (this.top.SubmenuPaddingHorz != null
		&& (position == "left" || position == "right"))
			return this.top.SubmenuPaddingHorz;

		if (this.top.SubmenuPaddingVert != null
		&& (position == "top" || position == "bottom"))
			return this.top.SubmenuPaddingVert;

		if (this.top.SubmenuPadding != null)
			return this.top.SubmenuPadding;
	}

	if (this.top.MenuPaddingHorz != null
	&& (position == "left" || position == "right"))
		return this.top.MenuPaddingHorz;

	if (this.top.MenuPaddingVert != null
	&& (position == "top" || position == "bottom"))
		return this.top.MenuPaddingVert;

	if (this.top.MenuPadding != null)
		return this.top.MenuPadding;

	return 0;
}

Menu.prototype.get_header_padding = function(position) {

	var padding = getPadding(this.header_e,position);

	if (getPadding.found) return padding;

	if (this.is_submenu) {
		if (this.top.SubmenuHeaderPaddingHorz != null
		&& (position == "left" || position == "right"))
			return this.top.SubmenuHeaderPaddingHorz;

		if (this.top.SubmenuHeaderPaddingVert != null
		&& (position == "top" || position == "bottom"))
			return this.top.SubmenuHeaderPaddingVert;

		if (this.top.SubmenuHeaderPadding != null)
			return this.top.SubmenuHeaderPadding;
	}

	return 0;
}

Menu.prototype.getBorderWidth = function() {
	if (this.BorderWidth == null) this.BorderWidth = Math.floor((this.get_border_width("left") + this.get_border_width("right"))/2);
	return this.BorderWidth;
}

Menu.prototype.getBorderHeight = function() {
	if (this.BorderHeight == null) this.BorderHeight = Math.floor((this.get_border_width("top") + this.get_border_width("bottom"))/2);
	return this.BorderHeight;
}

Menu.prototype.getHeaderBorderWidth = function() {
	if (this.HeaderBorderWidth == null) this.HeaderBorderWidth = Math.floor((this.get_header_border_width("left") + this.get_header_border_width("right"))/2);
	return this.HeaderBorderWidth;
}



/*
 * Utility functions
 */

function parseNum(s) {

	if (s) return parseInt("0"+s,10);
	return 0;
}

function getElementRef(id) {

	if (! id) return null;
	if (typeof id == "string") {
		if (document.getElementById) return document.getElementById(id);
		if (document.all) return document.all[id];
		return null;
	}
	if (typeof id == "object") return id;
	return null;
}

function getEventElementLeft(evt,target		,border_width,padding) {

	if (! evt) evt = window.event;
	if (! target) target = evt.target     ? evt.target     : 
			       evt.srcElement ? evt.srcElement : null;
	target = getElementRef(target);

	var x;

	var e, ox;
	var target_offset = 0, target_found = false;

	if (bv.isIE5 || bv.isOpr5) {

		if (border_width == null) border_width = getBorderWidth(target,"left");
		e = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;

		if (! e.nodeName || e.nodeName != "IMG"
		|| ! e.parentNode || e.parentNode.nodeName != "A"
		|| ! e.offsetParent || e.offsetParent.nodeName == "A") {

			while (e) {
				if (e == target) break;

				

				target_offset += e.offsetLeft;

				e = e.offsetParent;
			}
		}

		target_offset += border_width;

		x = evt.clientX - evt.offsetX - target_offset;

		if (bv.isIE5) x += document.body.scrollLeft;

		

		return x;
	}
	else if (bv.isIE5Mac) {

		if (border_width == null) border_width = getBorderWidth(e,"left");
		if (padding == null)      padding      = getPadding(e,"left");
		e = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;

		if (e.nodeName && e.nodeName == "IMG"
		&& e.parentNode && e.parentNode.nodeName == "A"
		&& e.offsetParent && e.offsetParent.nodeName != "A") {

			x = evt.clientX - evt.offsetX - border_width - padding;

			
		}
		else {
			ox = 0;
			while (e) {
				

				ox += e.offsetLeft;

				if (e == target) target_found = true;
				if (! target_found) { target_offset += e.offsetLeft; }

				e = e.offsetParent;
			}

			target_offset += border_width + padding;

			x = getMargin(document.body,"left") + ox - target_offset;

			
		}

		return x;
	}
	else if (bv.isOpr6) {

		x = getElementLeft(target);

		

		return x;
	}
	else {
		e = target;
		while (e && e.nodeType != 1) { e = e.parentNode };

		x = getElementLeft(e);

		

		return x;
	}

	return 0;
}

function getEventElementTop(evt,target		,border_width,padding) {

	if (! evt) evt = window.event;
	if (! target) target = evt.target     ? evt.target     : 
			       evt.srcElement ? evt.srcElement : null;
	target = getElementRef(target);

	var y;

	var e, oy;
	var target_offset = 0, target_found = false;

	if (bv.isIE5 || bv.isIE5Mac || bv.isOpr5) {

		if (border_width == null) border_width = getBorderWidth(target,"top");
		if (bv.isIE5Mac && padding == null) padding = getPadding(target,"top");
		e = evt.target ? evt.target : evt.srcElement ? evt.srcElement : null;
		oy = evt.offsetY;

		if (! e.nodeName || e.nodeName != "IMG"
		|| ! e.parentNode || e.parentNode.nodeName != "A"
		|| ! e.offsetParent || e.offsetParent.nodeName == "A") {

			while (e) {
				if (e == target) break;

				

				target_offset += e.offsetTop;

				e = e.offsetParent;
			}
		}

		target_offset += border_width;
		if (bv.isIE5Mac) target_offset += padding;

		y = evt.clientY - oy - target_offset;

		if (bv.isIE5) y += document.body.scrollTop;

		

		return y;
	}
	else if (bv.isOpr6) {

		y = getElementTop(target) + Menu.BodyMarginTop;

		

		return y;
	}
	else {
		e = target;
		while (e && e.nodeType != 1) { e = e.parentNode };

		y = getElementTop(e);

		

		return y;
	}

	return 0;
}

function getElementLeft(e) {

	

	var x = e.offsetLeft;

	while ((e = e.offsetParent)) {
		

		x += e.offsetLeft;
		x += getBorderWidth(e,"left");

		if (parseNum(e.border) > 0) {
			if (bv.isNS) x--;
			if (bv.isIE6 || bv.isOpr7) x++;
		}
	}

	

	return x;
}

function getElementTop(e) {

	

	var y = e.offsetTop;

	while ((e = e.offsetParent)) {
		

		y += e.offsetTop;
		y += getBorderWidth(e,"top");

		if (parseNum(e.border) > 0) {
			if (bv.isNS) y--;
			if (bv.isIE6 || bv.isOpr7) y++;
		}
	}

	

	return y;
}

function getElementStyle(e,
			dom_prop,		css_attr,
			dom_gen_prop,		css_gen_attr,     position,
			dom_border_prop,	css_border_attr,  component,
			dom_border_gen_prop,	css_border_gen_attr) {

	if (! css_attr) css_attr = dom_prop;

	var style;

	if (e.style) {
		if ((style = e.style[dom_prop])) {
			
		}
		else if (dom_gen_prop != null && (style = e.style[dom_gen_prop])) {
			
			style = parseStyleSetting(style,position);
		}
		else if (dom_border_prop != null && (style = e.style[dom_border_prop])) {
			
			style = parseBorderSetting(style,component);
		}
		else if (dom_border_gen_prop != null && (style = e.style[dom_border_gen_prop])) {
			
			style = parseBorderSetting(style,component);
		}

		if (style) {
			if (component == null || component != "width") {
				return style;
			}
			else {

				if (style.match(/\d/)) return style;
			}
		}
	}

	var v = document.defaultView;
	if (v && v.getComputedStyle) {
		style = v.getComputedStyle(e,"").getPropertyValue(css_attr);

		if (style != null) {
			
			return style;
		}

		if (css_gen_attr != null) {
			style = parseStyleSetting(
			  v.getComputedStyle(e,"").getPropertyValue(css_gen_attr),
			  position);

			if (style != null) {
				
				return style;
			}
		}

		if (css_border_attr != null) {
			style = parseBorderSetting(
			  v.getComputedStyle(e,"").getPropertyValue(css_border_attr),
			  component);

			if (style != null) {
				
				return style;
			}
		}

		if (css_border_gen_attr != null) {
			style = parseBorderSetting(
			  v.getComputedStyle(e,"").getPropertyValue(css_border_gen_attr),
			  component);

			if (style != null) {
				
				return style;
			}
		}
	}

	if (document.all && e.currentStyle) {
		style = e.currentStyle[dom_prop];

		if (style != null) {
			
			return style;
		}

		if (dom_gen_prop != null) {
			style = parseStyleSetting(
			  e.currentStyle[dom_gen_prop],
			  position);

			if (style != null) {
				
				return style;
			}
		}

		if (dom_border_prop != null) {
			style = parseBorderSetting(e.currentStyle[dom_border_prop],component);

			if (style != null) {
				
				return style;
			}
		}

		if (dom_border_gen_prop != null) {
			style = parseBorderSetting(e.currentStyle[dom_border_gen_prop],component);

			if (style != null) {
				
				return style;
			}
		}
	}

	

	return null;
}

function parseStyleSetting(setting,position) {

	if (! setting) return null;
	if (! position) return setting;
	setting.match(/(\S+)(\s+(\S+)(\s+(\S+)(\s+(\S+))?)?)?/);

	if (position == "top") {
		return RegExp.$1;
	}

	if (position == "right") {
		if (RegExp.$3) return RegExp.$3;
		return RegExp.$1;
	}

	if (position == "bottom") {
		if (RegExp.$5) return RegExp.$5;
		return RegExp.$1;
	}

	if (position == "left") {
		if (RegExp.$7) return RegExp.$7;
		if (RegExp.$3) return RegExp.$3;
		return RegExp.$1;
	}
}

function parseBorderSetting(setting,component) {

	if (! component || component == "width") {
		if (setting.match(/(\d+px)/)) return RegExp.$1;
		return 0;
	}
}

function getBorderWidth(e,position) {

	var width;
	
	var dom_gen_prop = "borderWidth";
	var css_gen_attr = "border-width";

	var dom_border_gen_prop = "border";
	var css_border_gen_attr = "border";

	if (! position) {
		width = getElementStyle(e,
			  dom_gen_prop,		css_gen_attr,
			  null,		 	null,			null,
			  dom_border_gen_prop,	css_border_gen_attr,	"width");
	}
	else {
		var Position = position.substr(0,1).toUpperCase()+position.substr(1);

		var dom_prop = "border"  + Position + "Width";
		var css_attr = "border-" + position + "-width";

		var dom_border_prop = "border"  + Position;
		var css_border_attr = "border-" + position;

		width = getElementStyle(e,
			  dom_prop,		css_attr,
			  dom_gen_prop,		css_gen_attr,		position,
			  dom_border_prop,	css_border_attr,	"width",
			  dom_border_gen_prop,	css_border_gen_attr);
	}
	if (width == null || ! width.match(/\d/)) {
		getBorderWidth.found = false;
		
		return 0;
	}
	else {
		getBorderWidth.found = true;
		return parseNum(width);
	}
}

function getPadding(e,position) {

	var padding;
	
	var s = "padding";

	if (! position) {
		padding = getElementStyle(e,s,s);
	}
	else {
		var Position = position.substr(0,1).toUpperCase()+position.substr(1);
		padding = getElementStyle(e, (s+Position), (s+"-"+position), s, s, position);
	}

	if (padding == null) {
		getPadding.found = false;
		
		return 0;
	}
	else {
		getPadding.found = true;
		return parseNum(padding);
	}
}

function getMargin(e,position) {

	var margin;
	
	var s = "margin";

	if (! position) {
		margin = getElementStyle(e,s,s);
	}
	else {
		var Position = position.substr(0,1).toUpperCase()+position.substr(1);
		margin = getElementStyle(e, (s+Position), (s+"-"+position), s, s, position);
	}

	if (margin == null) {
		getMargin.found = false;
		
		return 0;
	}
	else {
		getMargin.found = true;
		return parseNum(margin);
	}
}

function tableOffset(e) {

	var offset = 0;

	if (e && (e.nodeName == "TABLE" || bv.isOpr5 || bv.isOpr6)) {

		

		offset = (e.cellPadding == "" ? 1 : parseNum(e.cellPadding)) +
			 (e.cellSpacing == "" ? 1 : parseNum(e.cellSpacing)) +
			 parseNum(e.border);

		if (bv.isIE && e.cellPadding == "" && e.cellSpacing == "") offset++;
	}

	

	return offset;
}

/* Based on "Dynamic HTML The Definitive Reference" 2nd. Ed. by Danny Goodman p92. */

function getElementWidth(e,	border_width) {

	var result = 0;
	if (e.offsetWidth) {

		if (bv.isIE5Mac) {
			result = e.offsetWidth;
			
		}
		else {

			if (e.scrollWidth) {	result = e.scrollWidth; }
			else {			result = e.offsetWidth; }

			if (bv.isIE) {
				if (border_width == null) {
					result += getBorderWidth(e,"left") +
						  getBorderWidth(e,"right");
				}
				else {
					result += border_width * 2;
				}
			}
			
		}
	}
	else if (e.clip && e.clip.width) {
		result = e.clip.width;
		
	}
	else if (e.style && e.style.pixelWidth) {
		result = e.style.pixelWidth;
		
	}
	return parseInt(result);
}

function getElementHeight(e) {
	var result = 0;
	if (e.offsetHeight) {

		result = e.offsetHeight;
		
	}
	else if (e.clip && e.clip.height) {
		result = e.clip.height;
		
	}
	else if (e.style && e.style.pixelHeight) {
		result = e.style.pixelHeight;
		
	}
	return parseInt(result);
}



