=head1 NAME

Acme::Lister::Functions - Library of functions used in list format strings

=head1 SYNOPSIS

    use Local::Acme::Format	qw(sprintf_cmd);

    $format = sprintf_cmd("&total('table.column')");

=head1 DESCRIPTION

This is a library of functions that are available when formatting list rows,
headers, footers. They are invoked within format statements processed by the
sprintf_cmd() function located in the Local::Acme::Format module.

=head1 CHANGE LOG

 8/24/02  Initial version.

=head1 AUTHOR

Mack Pexton <mack@acmebase.org>

=head1 COPYRIGHT

Copyright 2002  Mackley F. Pexton.  All rights reserved.

This is open software and is licensed under the terms of the GNU General Public License.

=cut

#-------------------------------------------------------------------------------

sub total {
	my $col = shift;

	# Note: $_Totals is a hash planted in the sandbox by Acme::Lister
	# to hold the accumulated totals of columns. This function operates
	# withing that sandbox (package).

	return $_Totals{$col};
}

1;
