package Local::Acme::Import;

=head1 NAME

Local::Acme::Import - Convert records for import

=head1 SYNOPSIS

    use Local::Acme::Import;

    if (my $func = Local::Acme::Import::Conversions{$table}->{$import_type}) { &$func() };


=head1 DESCRIPTION

This module contains functins for converting import records before posting
them to the database.

Each conversion function has available global variables for every column in
the import and every column in the import table. The import table column 
names are fully qualified variables like: $customers__last_name.

=head1 AUTHOR

Mack Pexton <mack@acmebase.org>

=head1 COPYRIGHT

Copyright 2002, Mackley F. Pexton.  All rights reserved.

This is open software and is licensed under the terms of the GNU General Public License.

=cut

use strict;

require 5.6.0;
require Exporter;

use Acme::Config;

our @ISA = qw(Exporter);
our @EXPORT_OK = qw();

our $Scripts		= Acme::Config->Scripts;
our $Images		= Acme::Config->Images;
our $WWW		= Acme::Config->WWW;
our $Company_Banner	= Acme::Config->Company_Banner;
our $Company_Logo	= Acme::Config->Company_Logo;

1;
